//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdlib.h>
#include <stdio.h>

#include "Hlavicka.h"
#include "Figurka.h"
#include "Policko.h"
#include "Plan.h"
#include "Mozek.h"
#include "Hrac.h"
#include "Hlavni.h"
#include "PlanDialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#define LADENI false
TFormular *Formular;

int krouzek_r;  //polomer policka
int krouzek_rm; //figurka je znazornena krouzkem s timto polomerem
float kx;       //zkresleni souradnic ve smeru x
int rozmer;     //rozmer planu
int rotace;     //rotace planu
TPaintBox *pBox;
TStatusBar *sBar;

THalma::THalma(TFormular *formular_):TThread(true)
{
  jeHra = false;
  hracNaTahu = NULL;
  formular = formular_;
  rozmer = 4;
  rotace = 0;
  hraciPlan = new THraciPlan();
  hraciPocet = 3;
  hraci = new THrac*[hraciPocet];
  hraci_ = new THrac*[hraciPocet];
  hraci[0] = hraci_[0] = new THrac(this,hraciPlan,0,"Bitmapy/modra0.bmp","Bitmapy/modra1.bmp",formular->Label5,
    formular->Label7,formular->ComboBox1,formular->Image1);
  hraci[1] = hraci_[1] = new THrac(this,hraciPlan,1,"Bitmapy/cervena0.bmp","Bitmapy/cervena1.bmp",formular->Label10,
    formular->Label12,formular->ComboBox2,formular->Image2);
  hraci[2] = hraci_[2] = new THrac(this,hraciPlan,2,"Bitmapy/zelena0.bmp","Bitmapy/zelena1.bmp",formular->Label15,
    formular->Label17,formular->ComboBox3,formular->Image3);
  RozestavFigurkyStart();
  hracIndex1 = -1;
  hracIndex2 = -1;
  stav = -1;
  sBar->SimplePanel = true;
  sBar->SimpleText = AnsiString("Reim vchozho nastaven hry");
  formular->OpenDialog1->Filter = "Partie (*.dat)|*.dat|Vechny soubory(*.*)|*.*";
  formular->SaveDialog1->Filter = "Partie (*.dat)|*.dat|Vechny soubory(*.*)|*.*";
  formular->OpenDialog1->FilterIndex = 1;
  formular->SaveDialog1->FilterIndex = 1;
  formular->OpenDialog1->FileName = "Partie1.dat";
  formular->SaveDialog1->FileName = "Partie1.dat";
  //formular->OpenDialog1->InitialDir = "Partie";
  //formular->SaveDialog1->InitialDir = "Partie";
  formular->OpenDialog1->DefaultExt = String("dat");
  formular->SaveDialog1->DefaultExt = String("dat");
  adresar = GetCurrentDir();
}



void __fastcall THalma::Synchro(TThreadMethod Method)
{
  Synchronize(Method);
}

__fastcall THalma::~THalma(void)
{
  delete hraciPlan;
  int i;
  for (i = 0; i < 3; i++) delete hraci[i];
  delete hraci;
  delete hraci_;
}

void THalma::PridatTah(THrac *hrac)
{
  if (aktualniTahIndex < mezHistorieTahu)
  {
    tahyHistorie[aktualniTahIndex].tah.polickoStart = hrac->polickoStart;
    tahyHistorie[aktualniTahIndex].tah.polickoCil = hrac->polickoCil;
  }
  mezniTahIndex = ++aktualniTahIndex;
}

void THalma::VratitHraceDoHry()
{
  int i,j,k;
  hraciKonecPocet = 0;
  for (j = 0; j < 3; j++)
    if (hraci[j]->stav == VE_HRE) break;
  k = j;
  hracNaTahu = hraci[k];
  for (i = k + 1; i < 3; i++)
    if (hraci[i]->stav == VE_HRE)
    {
      hraci[j]->dalsi = hraci[i];
      hraci[i]->predchozi = hraci[j];
      j = i;
    }
  hraci[k]->predchozi = hraci[j];
  hraci[j]->dalsi = hraci[k];
  THrac *hrac = hracNaTahu;
  do
  {
    Synchro(hrac->ZobrazitSkore);
    Synchro(hrac->ZobrazitPocetTahu);
    hrac->potvrzeniKurzoru = false;
    hrac->jeZamknuto = false;
    hraciPlan->pocetFigurekVChlivecku[hrac->orientace] = hraciPocet - 1;
    hrac->polickoStart = NULL;
    hrac->polickoCil = NULL;
    hrac = hrac->dalsi;
  } while (hrac != hracNaTahu);
}


void THalma::HlaseniOVysledku()
{
}

void THalma::ZmenaStavuHrace_(int i)
{
  hracIndex1 = i;
  ZmenaStavuHrace();
}

void __fastcall THalma::ZmenaStavuHrace()
{
  int hracCislo = hracIndex1;
  if (!jeHra)
  {
    if (hraci[hracCislo]->stav == MIMO_HRU)
    {
      hraci[hracCislo]->NastavitBitMapuStart();
      hraci[hracCislo]->RozestavFigurkyStart();
      hraci[hracCislo]->stav = VE_HRE;
      hraciPocet++;
    }
    else
      if (hraciPocet != 1)
      {
        hraci[hracCislo]->NastavitBitMapuSedou();
        hraci[hracCislo]->SejmiFigurky();
        hraciPocet--;
        hraci[hracCislo]->stav = MIMO_HRU;
      }
    hracIndex1 = -1;
    hracIndex2 = -1;
  }
}

void THalma::RozestavFigurkyStart()
{
  for(int i = 0; i < 3; i++)
    if (hraci[i]->stav != MIMO_HRU) hraci[i]->RozestavFigurkyStart();
}

void THalma::SejmiFigurky()
{
  for(int i = 0; i < 3; i++)
    if (hraci[i]->stav != MIMO_HRU) hraci[i]->SejmiFigurky();
}

void __fastcall THalma::ZamenaHracu()
{
  THrac *hrac1 = hraci[hracIndex1];
  THrac *hrac2 = hraci[hracIndex2];

  hrac1->hracCislo = hracIndex2;
  hrac2->hracCislo = hracIndex1;

  TLabel *lSkore = hrac1->lSkore;
  TLabel *lPocetTahu = hrac1->lPocetTahu;
  TComboBox *cBox= hrac1->cBox;
  TImage *image= hrac1->image;

  hrac1->lSkore = hrac2->lSkore;
  hrac1->lPocetTahu = hrac2->lPocetTahu;
  hrac1->cBox = hrac2->cBox;
  hrac1->image = hrac2->image;

  hrac2->lSkore = lSkore;
  hrac2->lPocetTahu = lPocetTahu;
  hrac2->cBox = cBox;
  hrac2->image = image;

  AnsiString text1 = hrac1->cBox->Text;
  AnsiString text2 = hrac2->cBox->Text;

  int itemIndex = hrac1->cBox->ItemIndex;
  hrac1->cBox->ItemIndex = hrac2->cBox->ItemIndex;
  hrac2->cBox->ItemIndex = itemIndex;

  if (hrac1->cBox->ItemIndex == -1) hrac1->cBox->Text = text2;
  if (hrac2->cBox->ItemIndex == -1) hrac2->cBox->Text = text1;
  NastavitAdresar();
  if (hrac1->stav == VE_HRE) hrac1->NastavitBitMapuStart();
    else hrac1->image->Picture->LoadFromFile("Bitmapy/seda.bmp");
  if (hrac2->stav == VE_HRE) hrac2->NastavitBitMapuStart();
    else hrac2->image->Picture->LoadFromFile("Bitmapy/seda.bmp");

  hraci[hracIndex1] = hrac2;
  hraci[hracIndex2] = hrac1;
}

void THalma::NastavitAdresar()
{
  SetCurrentDir(adresar);
}

void THalma::RotacePlanu(int rotaceDelta)
{
  if (jeHra && hracNaTahu != NULL)
  {
    hracNaTahu->rotaceDleHrace =
       (hracNaTahu->rotaceDleHrace + 6 + rotaceDelta) % 6;
    if (hracNaTahu->jeZamknuto)
    {
      hracNaTahu->udalost_ = 1;
      return;
    }
    hraciPlan->RotacePlanu(hracNaTahu->rotaceDleHrace);
  } else hraciPlan->RotacePlanu((rotace + 6 + rotaceDelta) % 6);
}


void __fastcall THalma::ZmenaPlanu()
{
  int i;
  int rozmer_ = rozmer;
  rotace = 0;
  for(i = 0; i < 3; i++)
  {
    hraci[i]->pocetTahu = 0;
    hraci[i]->ohodnoceniPozice = 0;
    hraci[i]->ZobrazitPocetTahu();
    hraci[i]->ZobrazitSkore();
    if (hraci[i]->stav == HOTOVY)
    {
       hraci[i]->stav = VE_HRE;
       hraci[i]->NastavitBitMapuStart();
    }
  }
  sBar->SimpleText = AnsiString("Reim vchozho nastaven hry");
  rozmer = PlanVelikostDialog->CSpinEdit1->Value;
  rotace = 0;
  if (rozmer_ != rozmer)
  {
    delete hraciPlan;
    for(i = 0; i < 3; i++) hraci[i]->ZrusitFigurky();
    hraciPlan = new THraciPlan();
    for(i = 0; i < 3; i++)
    {
      hraci[i]->NastavitFigurkyAChlivecek(hraciPlan);
      hraci[i]->RozestavFigurkyStart();
      hraci[i]->mozek->hraciPlan = hraciPlan;
      if (hraci[i]->stav == MIMO_HRU) hraci[i]->SejmiFigurky();
    }
  } else
  {
    SejmiFigurky();
    RozestavFigurkyStart();
    //hraciPlan->RotacePlanu(rotace);
  }
  pBox->Repaint();
}

void THalma::NovaHra()
{
  if (PlanVelikostDialog->ShowModal() == mrOk)
  {
    if (jeHra && hracNaTahu != NULL)
    {
      hracNaTahu->udalost = 1;
    } else
      if (stav == 0) ZmenaPlanu();
    if (stav == -1) ZmenaPlanu();
  }
}

void __fastcall THalma::TahniFigurkouVykresli()
{
  hracNaTahu->TahniFigurkouVykresli(
   tahyHistorie[aktualniTahIndex].tah.polickoStart,
   tahyHistorie[aktualniTahIndex].tah.polickoCil);
}

void __fastcall THalma::TahniFigurkouInverzneVykresli()
{
  hracNaTahu->TahniFigurkouVykresli(
   tahyHistorie[aktualniTahIndex].tah.polickoCil,
   tahyHistorie[aktualniTahIndex].tah.polickoStart);
}

void  THalma::ProvestTahZpet(bool vykreslit)
{
  if (aktualniTahIndex > 0 && aktualniTahIndex < mezHistorieTahu) //tah zpet
  {
    if (hraciKonecPocet != hraciPocet)
    {
      hracNaTahu->pocetTahu--;
      Synchro(hracNaTahu->ZobrazitPocetTahu);
    }
    if (aktualniTahIndex == mezniTahIndex)
	{
	  tahyHistorie[aktualniTahIndex].tah.polickoStart = hracNaTahu->polickoStart;
	  tahyHistorie[aktualniTahIndex].tah.polickoCil = hracNaTahu->polickoCil;
	}
	aktualniTahIndex--;
	if (tahyHistorie[aktualniTahIndex].hracKoncici == NULL)
      hracNaTahu = hracNaTahu->predchozi;
    else
	{
	  hracNaTahu = tahyHistorie[aktualniTahIndex].hracKoncici;
      Synchro(hracNaTahu->NastavitBitMapuStart);
	  Synchro(hracNaTahu->ZaplnitChlivecekInverzeVykresli);
      Synchro(hracNaTahu->ZobrazitSkore);
      hracNaTahu->stav = VE_HRE;
	 //vraceni hrace do hry
	  hraciKonecPocet--;
	  hracNaTahu->dalsi->predchozi = hracNaTahu;
	  hracNaTahu->predchozi->dalsi = hracNaTahu;
	}
	hracNaTahu->NastavitKurzor(&tahyHistorie[aktualniTahIndex].tah);
    if (vykreslit)
      Synchro(TahniFigurkouInverzneVykresli);
    else
      hracNaTahu->TahniFigurkouVykresli(
       tahyHistorie[aktualniTahIndex].tah.polickoCil,
       tahyHistorie[aktualniTahIndex].tah.polickoStart);
 } else hracNaTahu->potvrzeniKurzoru = true;
}

int THalma::VratitPocetHracuVeHre()
{
  return hraciPocet - hraciKonecPocet;
}

bool THalma::NacistPartii()
{
  int aktualniTahIndex_;
  int i,i1,i2,i3,i4;
  FILE *fr; //Proudy pro cteni a ukladani partii
  char radka[200],radka_[20]; int radkaDelka = 200;
  SetCurrentDir(AnsiString(adresar) + AnsiString("/Partie"));
  if (formular->OpenDialog1->Execute())
  {
    fr = fopen(formular->OpenDialog1->FileName.c_str(),"r");
    fgets(radka,radkaDelka,fr);
    fgets(radka,radkaDelka,fr);
    fscanf(fr,"%d  %d  %d\r\n",&i1,&i2,&i3);
    //Nastaveni poradi hracu
    if (hraci[0]->orientace != i1 % 3)
    {
      hracIndex1 = 0;
      hracIndex2 = hraci_[i1 % 3]->hracCislo;
      Synchro(ZamenaHracu);
    }
    //Na pozici 0 v poli hraci mam hrace i1
    if ((i1 > 2 && hraci[0]->stav != MIMO_HRU) ||
        (i1 <= 2 && hraci[0]->stav == MIMO_HRU))
    {
      hracIndex1 = 0;
      jeHra = false;
      Synchro(ZmenaStavuHrace);
      jeHra = true;
    }
    if (hraci[1]->orientace != i2 % 3)
    {
      hracIndex1 = 1;
      hracIndex2 = hraci_[i2 % 3]->hracCislo;//tedy dvojka
      Synchro(ZamenaHracu);
    }
    //Na pozici 1 v poli hraci mam hrace i2
    if ((i2 > 2 && hraci[1]->stav != MIMO_HRU) ||
        (i2 <= 2 && hraci[1]->stav == MIMO_HRU))
    {
      hracIndex1 = 1;
      jeHra = false;
      Synchro(ZmenaStavuHrace);
      jeHra = true;
    }
    //Na pozici 2 v poli hraci mam hrace i3
    if ((i3 > 2 && hraci[2]->stav != MIMO_HRU) ||
        (i3 <= 2 && hraci[2]->stav == MIMO_HRU))
    {
      hracIndex1 = 2;
      jeHra = false;
      Synchro(ZmenaStavuHrace);
      jeHra = true;
    }
    fgets(radka,radkaDelka,fr);
    for (i = 0; i < 3; i++)
    {
      fscanf(fr,"%s  %d\r\n",radka_,&i1);
      strcpy(radka,radka_ + 1);
      /*if (strcmp(radka_,"#")) strcpy(radka,"");
      else strcpy(radka,radka_ + 1); */
      hraci[i]->cBox->Text = AnsiString(radka);
      hraci[i]->cBox->ItemIndex = i1;
    }
    //Nacteni rozmeru a indexu tahu
    fgets(radka,radkaDelka,fr);
    fscanf(fr,"%d  %d\r\n",&i,&aktualniTahIndex_);
    PlanVelikostDialog->CSpinEdit1->Value = i;
    if (i != rozmer) ZmenaPlanu();
    //Nacteni seznamu tahu
    fgets(radka,radkaDelka,fr);
    i = 0;
    while (!feof(fr))
    {
      fscanf(fr,"%4d %4d   %4d %4d\r\n",&i1,&i2,&i3,&i4);
      if (i1 == hraciPlan->posunMaticeMetriky + 1)
        tahyHistorie[i].tah.polickoStart = NULL;
      else
        tahyHistorie[i].tah.polickoStart =
          hraciPlan->maticeMetriky[i1 + hraciPlan->posunMaticeMetriky]
                                  [i2 + hraciPlan->posunMaticeMetriky];
      if (i3 == hraciPlan->posunMaticeMetriky + 1)
        tahyHistorie[i].tah.polickoCil = NULL;
      else
        tahyHistorie[i].tah.polickoCil =
          hraciPlan->maticeMetriky[i3 + hraciPlan->posunMaticeMetriky]
                                  [i4 + hraciPlan->posunMaticeMetriky];
      i++;
    }
    mezniTahIndex = i - 1;
    Synchro(ZmenaPlanu);
    VratitHraceDoHry();//vzajemne propojeni hracu a jejich interni nastaveni
    //Pruchod historii tahu vpred a nastaveni hracKoncici
    for (i = 0; i < mezniTahIndex; i++)
    {
      hracNaTahu->TahniFigurkou(tahyHistorie[i].tah.polickoStart,
                                tahyHistorie[i].tah.polickoCil);
      hracNaTahu->pocetTahu++;
      if (hracNaTahu->JeChlivecekPlny())
      {
        hracNaTahu->ZaplnitChlivecek();
        Synchro(hracNaTahu->NastavitBitMapuCil);
        hracNaTahu->stav = HOTOVY;
        hraciKonecPocet++;//hrac dohral
	    tahyHistorie[i].hracKoncici = hracNaTahu;
	    if (hraciKonecPocet < hraciPocet)
	    {
	      //vyrazeni hrace
          hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	      hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	      hracNaTahu = hracNaTahu->dalsi;
	    }
      } else
      {
        tahyHistorie[i].hracKoncici = NULL;//Ok
        hracNaTahu = hracNaTahu->dalsi;
      }
    }
    aktualniTahIndex = mezniTahIndex;
    hracNaTahu->potvrzeniKurzoru = true;
    hracNaTahu->pocetTahu++;
    hracNaTahu->polickoStart = tahyHistorie[mezniTahIndex].tah.polickoStart;
    hracNaTahu->polickoCil = tahyHistorie[mezniTahIndex].tah.polickoCil;
    for (i = mezniTahIndex; i > aktualniTahIndex_; i--)
      ProvestTahZpet(false);
    for (i = 0; i < 3; i++)
      if (hraci[i]->stav != MIMO_HRU)
      {
        Synchro(hraci[i]->ZobrazitPocetTahu);
        Synchro(hraci[i]->ZobrazitSkore);
      }
    Synchro(pBox->Repaint);
    fclose(fr);
    return true;
  }
  return false;
}

void __fastcall THalma::VlastniHra()
{
  FILE *fw; //Proudy pro cteni a ukladani partii
  THrac *hrac;
  do
  {
     if (hracNaTahu->predchozi->pocetTahu == hracNaTahu->pocetTahu) //kolo obehlo
     {
       hrac = hracNaTahu;
       do {
         hrac->ohodnoceniPozice_ = hrac->ohodnoceniPozice;
         hrac = hrac->dalsi;
       }
       while (hrac != hracNaTahu);
     }

     switch (hracNaTahu->Tah()){
       case 0:
           if (aktualniTahIndex < mezHistorieTahu) tahyHistorie[aktualniTahIndex].hracKoncici = NULL;//Ok
	       PridatTah(hracNaTahu);//potvrzeni tahu
	       hracNaTahu = hracNaTahu->dalsi;
           hracNaTahu->potvrzeniKurzoru = false;
           if (LADENI  && aktualniTahIndex < mezHistorieTahu)//prubezne ukladani
           {
             SetCurrentDir(AnsiString(adresar) + AnsiString("/Partie"));
             fw = fopen(formular->SaveDialog1->FileName.c_str(),"wb");
             fprintf(fw,"Datovy soubor partie hry halma\r\n");
             fprintf(fw,"Cisla hracu podle jejich poradi\r\n");
             fprintf(fw,"%4d  %4d  %4d\r\n",hraci[0]->VratitId(),
                                            hraci[1]->VratitId(),
                                            hraci[2]->VratitId());
             fprintf(fw,"Rozmer planu a index aktualniho tahu\r\n");
             fprintf(fw,"%4d  %4d\r\n",rozmer,aktualniTahIndex);
             fprintf(fw,"Seznam tahu\r\n");
             for (int i = 0; i < mezniTahIndex; i++)
             {
               fprintf(fw,"%4d %4d   %4d %4d\r\n",
                 tahyHistorie[i].tah.polickoStart->vzdalenostOdDomova[1],
                 tahyHistorie[i].tah.polickoStart->vzdalenostOdDomova[0],
                 tahyHistorie[i].tah.polickoCil->vzdalenostOdDomova[1],
                 tahyHistorie[i].tah.polickoCil->vzdalenostOdDomova[0]);
             }
             //Posleni zaznam neni tah, ale nastaveni kurzoru
             if (tahyHistorie[mezniTahIndex].tah.polickoStart != NULL)
             {
               fprintf(fw,"%4d %4d   %4d %4d\r\n",
                 tahyHistorie[mezniTahIndex].tah.polickoStart->vzdalenostOdDomova[1],
                 tahyHistorie[mezniTahIndex].tah.polickoStart->vzdalenostOdDomova[0]);
               if (tahyHistorie[mezniTahIndex].tah.polickoCil != NULL)
                 fprintf(fw,"%4d %4d",
                 tahyHistorie[mezniTahIndex].tah.polickoCil->vzdalenostOdDomova[1],
                 tahyHistorie[mezniTahIndex].tah.polickoCil->vzdalenostOdDomova[0]);
               else
                 fprintf(fw,"   %4d %4d\r\n",
                  hraciPlan->posunMaticeMetriky + 1,
                  hraciPlan->posunMaticeMetriky + 1);
             } else fprintf(fw,"%4d %4d   %4d %4d\r\n",
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1);
             fclose(fw);
           }
	       break;
       case 1://nastaveni zacatku hry - obsluha je v miste nastaveni udalosti
	       return;
       case 2://hrac chce ukoncit beh programu
           stav = 1;
           return;
       case 3: ProvestTahZpet(true);//tah zpet
           break;
       case 4://Tah vpred
           if (aktualniTahIndex < mezniTahIndex  && aktualniTahIndex + 1 < mezHistorieTahu)//tah vpred
	       {
             Synchro(TahniFigurkouVykresli);
             Synchro(hracNaTahu->ZobrazitSkore);
		     if (tahyHistorie[aktualniTahIndex].hracKoncici != NULL)
		     {
		       hraciKonecPocet++;
		       //hrac = tahyHistorie[aktualniTahIndex].hracKoncici;
		       Synchro(hracNaTahu->ZaplnitChlivecekVykresli);
               //Synchro(hracNaTahu->ZobrazitSkore);
               Synchro(hracNaTahu->NastavitBitMapuCil);
               hracNaTahu->stav = HOTOVY;
	     	   if (hraciKonecPocet != hraciPocet)
		       {
		         //vyrazeni hrace
		         hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
		         hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
		       }
		     }
		     aktualniTahIndex++;
		     hracNaTahu = hracNaTahu->dalsi;
             if (hraciKonecPocet != hraciPocet)
             {
               hracNaTahu->pocetTahu++;
               Synchro(hracNaTahu->ZobrazitPocetTahu);
             }
             hracNaTahu->NastavitKurzor(&tahyHistorie[aktualniTahIndex].tah);
	       } else hracNaTahu->potvrzeniKurzoru = true;
           break;
       case 5:hraciKonecPocet++;//hrac dohral
	       tahyHistorie[aktualniTahIndex].hracKoncici = hracNaTahu;
	       PridatTah(hracNaTahu);
	       if (hraciKonecPocet < hraciPocet)
	       {
	  	     //vyrazeni hrace
		     hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
		     hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
		     hracNaTahu = hracNaTahu->dalsi;
	       }
	       break;
       case 7://Ulozeni partie
           hracNaTahu->potvrzeniKurzoru = true;
           SetCurrentDir(AnsiString(adresar) + AnsiString("/Partie"));
           if (formular->SaveDialog1->Execute())
           {
             fw = fopen(formular->SaveDialog1->FileName.c_str(),"wb");
             fprintf(fw,"Datovy soubor partie hry halma\r\n");
             fprintf(fw,"Cisla hracu podle jejich poradi\r\n");
             fprintf(fw,"%4d  %4d  %4d\r\n",hraci[0]->VratitId(),
                                            hraci[1]->VratitId(),
                                            hraci[2]->VratitId());
             int i;
             fprintf(fw,"Jmeno hrace a index jmena v seznamu\r\n");
             char retez[30];
             for (i = 0; i < 3; i++)
             {
               sprintf(retez,"#%s",hraci[i]->cBox->Text.c_str());
               fprintf(fw,"%-10s  %4d\r\n",retez,hraci[i]->cBox->ItemIndex);
             }
             fprintf(fw,"Rozmer planu a index aktualniho tahu\r\n");
             //Mohu ulozit jen to, co se da
             int mez = (mezniTahIndex < mezHistorieTahu) ? mezniTahIndex : mezHistorieTahu - 1;
             int aktual = (aktualniTahIndex < mezHistorieTahu) ? aktualniTahIndex : mez;
             fprintf(fw,"%4d  %4d\r\n",rozmer,aktual);
             fprintf(fw,"Seznam tahu\r\n");
             for (i = 0; i < mez; i++)
             {
               fprintf(fw,"%4d %4d   %4d %4d\r\n",
                 tahyHistorie[i].tah.polickoStart->vzdalenostOdDomova[1],
                 tahyHistorie[i].tah.polickoStart->vzdalenostOdDomova[0],
                 tahyHistorie[i].tah.polickoCil->vzdalenostOdDomova[1],
                 tahyHistorie[i].tah.polickoCil->vzdalenostOdDomova[0]);
             }
             //Posleni zaznam neni tah, ale nastaveni kurzoru
             if (aktual == mez)
             {
               tahyHistorie[aktual].tah.polickoStart = hracNaTahu->polickoStart;
               tahyHistorie[aktual].tah.polickoCil = hracNaTahu->polickoCil;
             }
             if (tahyHistorie[mez].tah.polickoStart != NULL)
             {
               fprintf(fw,"%4d %4d   ",
                 tahyHistorie[mez].tah.polickoStart->vzdalenostOdDomova[1],
                 tahyHistorie[mez].tah.polickoStart->vzdalenostOdDomova[0]);
               if (tahyHistorie[mez].tah.polickoCil != NULL)
                 fprintf(fw,"%4d %4d\r\n",
                 tahyHistorie[mez].tah.polickoCil->vzdalenostOdDomova[1],
                 tahyHistorie[mez].tah.polickoCil->vzdalenostOdDomova[0]);
               else
                 fprintf(fw,"%4d %4d\r\n",
                  hraciPlan->posunMaticeMetriky + 1,
                  hraciPlan->posunMaticeMetriky + 1);
             } else fprintf(fw,"%4d %4d   %4d %4d\r\n",
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1,
                hraciPlan->posunMaticeMetriky + 1);
             fclose(fw);
           }
           break;
     case 8://Nacteni partie
           NacistPartii();
           break;
     case 9: hracNaTahu->potvrzeniKurzoru = !hracNaTahu->potvrzeniKurzoru;
     }
     //Synchro(pBox->Repaint);
  } while (true);
  /*while (hraciKonecPocet != hraciPocet);
  HlaseniOVysledku();*/
}

void THalma::VyberHrace(int hracCislo)
{
  if (!jeHra)
    if (hracIndex1 == -1) hracIndex1 = hracCislo;
    else
    if (hracIndex1 != hracCislo)
    {
      hracIndex2 = hracCislo;
      ZamenaHracu();
      hracIndex1 = -1;
      hracIndex2 = -1;
    }
}

bool THalma::JeHra()
{
  return jeHra;
}

void THalma::Rada()
{
  if (hracNaTahu != NULL) hracNaTahu->Rada();
}

void __fastcall THalma::Execute(void)
{
  do{
    if (stav == 2)
    {
      //Nacteni partie
      while (stav == 2)
      {
        stav = 0;
        if (!NacistPartii())
        {
          Suspend();
          if (stav != 2)
          {
            VratitHraceDoHry();//vzajemne propojeni hracu a jejich interni nastaveni
            aktualniTahIndex = 0; //zruseni historie
            mezniTahIndex = 0;
          }
        }
      }
    } else
    {
      stav = 0;
      VratitHraceDoHry();//vzajemne propojeni hracu a jejich interni nastaveni
      aktualniTahIndex = 0; //zruseni historie
      mezniTahIndex = 0;
    }
    jeHra = true;
    VlastniHra();
    hracNaTahu = NULL;
    jeHra = false;
    if (stav != 1) Synchro(ZmenaPlanu); //neni-li konec
    if (stav == 0) Suspend();//Nova hra, vlakno se uspi
    //Priority = tpNormal;
  } while (stav != 1);//Dokud neni konec
}

void THalma::TahZpet()
{
  if (jeHra && hracNaTahu != NULL)
  {
    //if (hracNaTahu->jeZamknuto) return;
    hracNaTahu->udalost = 3;
  }
}


void THalma::TahVpred()
{
  if (jeHra && hracNaTahu != NULL)
  {
    //if (hracNaTahu->jeZamknuto) return;
    hracNaTahu->udalost = 4;
  }
}

bool THalma::KonecProgramu()
{
  if (MessageBox(NULL,"Opravdu chcete skonit ?","Halma", MB_YESNO) == IDYES)
  {
    if (jeHra && hracNaTahu != NULL)
    {
      hracNaTahu->udalost = 2;
      WaitFor();
      jeHra = false;
    }
    return true;
  }
  return false;
}

void THalma::ZpracovaniKliknutiNaPlan(int X,int Y)
{
  if (jeHra && hracNaTahu != NULL) hracNaTahu->ZpracovatKliknuti(X,Y);
}

void THalma::ZruseniVlakna()
{
  if (Suspended && stav != -1)
  {
    stav = 1;
    Resume();
  } else
  if (jeHra && hracNaTahu != NULL)
  {
    hracNaTahu->udalost = 2;
    WaitFor();
    jeHra = false;
  }
}

void THalma::StartStopHry()
{
  if (!jeHra) Resume();
  else if (hracNaTahu != NULL) hracNaTahu->udalost = 9;
}

void THalma::PrepnoutAnimaci()
{
  if (jeHra && hracNaTahu != NULL)
  {
    hraciPlan->PrepnoutAnimaci();
    if (hracNaTahu->jeZamknuto) hracNaTahu->udalost = 6;
  }
}

void THalma::Ulozit()
{
  if (jeHra && hracNaTahu != NULL) hracNaTahu->udalost = 7;
}

void THalma::Nacist()
{
  if (jeHra && hracNaTahu != NULL) hracNaTahu->udalost = 8;
  else
  {
    stav = 2;
    Resume();
  }
}
//---------------------------------------------------------------------------
__fastcall TFormular::TFormular(TComponent* Owner)
    : TForm(Owner)
{
  Application->HelpFile = "ohre.hlp";
  pBox = PaintBox1;
  sBar  = StatusBar1;
  halma = new THalma(this);
}
//---------------------------------------------------------------------------

__fastcall TFormular::~TFormular(void)
{
  halma->ZruseniVlakna();
  delete halma;
}

//---------------------------------------------------------------------------

void __fastcall TFormular::Image1DblClick(TObject *Sender)
{
  halma->ZmenaStavuHrace_(0);
}
//---------------------------------------------------------------------------



void __fastcall TFormular::StartHryClick(TObject *Sender)
{
  halma->StartStopHry();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Rotacedoleva1Click(TObject *Sender)
{
  halma->RotacePlanu(1);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::PaintBox1Paint(TObject *Sender)
{
  halma->RotacePlanu(0);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Rotacedoprava1Click(TObject *Sender)
{
  halma->RotacePlanu(-1);
}
//---------------------------------------------------------------------------



void __fastcall TFormular::Image2DblClick(TObject *Sender)
{
  halma->ZmenaStavuHrace_(1);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Image3DblClick(TObject *Sender)
{
  halma->ZmenaStavuHrace_(2);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Image1Click(TObject *Sender)
{
  halma->VyberHrace(0);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Image2Click(TObject *Sender)
{
  halma->VyberHrace(1);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Image3Click(TObject *Sender)
{
  halma->VyberHrace(2);
}
//---------------------------------------------------------------------------



void __fastcall TFormular::Ukonenprogramu1Click(TObject *Sender)
{
  if (halma->KonecProgramu()) Close();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Novhra1Click(TObject *Sender)
{
  halma->NovaHra();
}
//---------------------------------------------------------------------------


void __fastcall TFormular::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  halma->ZpracovaniKliknutiNaPlan(X,Y);
}
//---------------------------------------------------------------------------


void __fastcall TFormular::Rada1Click(TObject *Sender)
{
  if (halma->JeHra()) halma->Rada();
}
//---------------------------------------------------------------------------


void __fastcall TFormular::Tahzpt1Click(TObject *Sender)
{
  halma->TahZpet();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Tahvped1Click(TObject *Sender)
{
  halma->TahVpred();
}
//---------------------------------------------------------------------------





void __fastcall TFormular::SpeedButton1Click(TObject *Sender)
{
  halma->RotacePlanu(1);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton2Click(TObject *Sender)
{
  halma->RotacePlanu(-1);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton3Click(TObject *Sender)
{
  halma->TahZpet();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton4Click(TObject *Sender)
{
  halma->TahVpred();
}
//---------------------------------------------------------------------------



void __fastcall TFormular::Vypnoutzapnout2Click(TObject *Sender)
{
  halma->PrepnoutAnimaci();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Uloit1Click(TObject *Sender)
{
  halma->Ulozit();
}
//---------------------------------------------------------------------------


void __fastcall TFormular::Nast1Click(TObject *Sender)
{
  halma->Nacist();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton3MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  halma->TahZpet();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton3MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  halma->TahZpet();
}
//---------------------------------------------------------------------------


void __fastcall TFormular::SpeedButton5Click(TObject *Sender)
{
  halma->PrepnoutAnimaci();
}
//---------------------------------------------------------------------------


void __fastcall TFormular::SpeedButton6Click(TObject *Sender)
{
  if (halma->JeHra()) halma->Rada();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton7Click(TObject *Sender)
{
  halma->Nacist();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton8Click(TObject *Sender)
{
  halma->Ulozit();
}
//---------------------------------------------------------------------------

void __fastcall TFormular::Pomoc1Click(TObject *Sender)
{
  //Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

void __fastcall TFormular::SpeedButton9Click(TObject *Sender)
{
  halma->StartStopHry();
}
//---------------------------------------------------------------------------

