//---------------------------------------------------------------------------
#ifndef HlavniH
#define HlavniH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
#define mezHistorieTahu 1000

typedef struct{
  TTah tah;
  THrac *hracKoncici;
} TPolozkaHistorie;

class TFormular;

struct THalma: public TThread
{
private:	// User declarations
  THraciPlan *hraciPlan;
  int hraciPocet;
  THrac **hraci,**hraci_;//pole ukazatelu na hrace, hraci_ je pevne
  THrac *hracNaTahu;
  int aktualniTahIndex,mezniTahIndex;
  TPolozkaHistorie tahyHistorie[mezHistorieTahu];
  int hracIndex1,hracIndex2;
  bool jeHra;
  TFormular *formular;
  int stav;
  int hraciKonecPocet;//pocet hracu ve stavu HOTOVO
  AnsiString adresar;
public:		// User declarations
  void __fastcall VlastniHra();
  void VratitHraceDoHry();
  void HlaseniOVysledku();
  void SejmiFigurky();
  void RozestavFigurkyStart();
  void PridatTah(THrac *hrac);
  void __fastcall ZamenaHracu();
  void ZmenaStavuHrace_(int i);
  void __fastcall ZmenaStavuHrace();
  void VyberHrace(int hracCislo);
  void NovaHra();
  int VratitPocetHracuVeHre();
  void RotacePlanu(int rotaceDelta);
  void ZpracovaniKliknutiNaPlan(int X,int Y);
  void ProvestTahZpet(bool vykreslit);
  bool JeHra();
  void Rada();
  void TahZpet();
  void TahVpred();
  bool KonecProgramu();
  void ZruseniVlakna();
  void StartStopHry();
  void PrepnoutAnimaci();
  void NastavitAdresar();
  void Nacist();//Nastavi signaly
  bool NacistPartii();//Provede nacteni partie
  void Ulozit();
  void __fastcall Synchro(TThreadMethod Method);
  void __fastcall TahniFigurkouVykresli();
  void __fastcall TahniFigurkouInverzneVykresli();
  void __fastcall ZmenaPlanu();
  virtual void __fastcall Execute(void);
  THalma(TFormular *formular_);
  __fastcall virtual ~THalma(void);
};


class TFormular : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *Hra1;
    TMenuItem *Tahy1;
    TMenuItem *Pln1;
    TMenuItem *Novhra1;
    TMenuItem *StartHry;
    TMenuItem *Rada1;
    TMenuItem *Tahzpt1;
    TMenuItem *Tahvped1;
    TMenuItem *Rotacedoleva1;
    TMenuItem *Rotacedoprava1;
    TPanel *Panel1;
    TGroupBox *GroupBox2;
    TPanel *Panel3;
    TGroupBox *GroupBox1;
    TPanel *Panel4;
    TGroupBox *GroupBox3;
    TPanel *Panel5;
    TGroupBox *GroupBox4;
    TPanel *Panel6;
    TGroupBox *GroupBox5;
    TPanel *Panel7;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TComboBox *ComboBox1;
    TComboBox *ComboBox2;
    TComboBox *ComboBox3;
    TLabel *Label4;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TPanel *Panel8;
    TStatusBar *StatusBar1;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TLabel *Label13;
    TImage *Image1;
    TPanel *Panel9;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TPanel *Panel10;
    TImage *Image2;
    TImage *Image3;
    TMenuItem *Konechry2;
    TMenuItem *Ukonenprogramu1;
    TPaintBox *PaintBox1;
    TToolBar *ToolBar1;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TSpeedButton *SpeedButton3;
    TSpeedButton *SpeedButton4;
    TBevel *Bevel1;
    TMenuItem *Animace1;
    TMenuItem *Vypnoutzapnout2;
    TMenuItem *Nast1;
    TMenuItem *Uloit1;
    TMenuItem *N1;
    TSaveDialog *SaveDialog1;
    TOpenDialog *OpenDialog1;
    TSpeedButton *SpeedButton5;
    TSpeedButton *SpeedButton6;
    TSpeedButton *SpeedButton7;
    TSpeedButton *SpeedButton8;
    TMenuItem *Pomoc1;
    TSpeedButton *SpeedButton9;
    void __fastcall Image1DblClick(TObject *Sender);
    void __fastcall StartHryClick(TObject *Sender);
    void __fastcall Rotacedoleva1Click(TObject *Sender);
    void __fastcall PaintBox1Paint(TObject *Sender);
    void __fastcall Rotacedoprava1Click(TObject *Sender);


    void __fastcall Image2DblClick(TObject *Sender);
    void __fastcall Image3DblClick(TObject *Sender);
    void __fastcall Image1Click(TObject *Sender);
    void __fastcall Image2Click(TObject *Sender);
    void __fastcall Image3Click(TObject *Sender);

    void __fastcall Ukonenprogramu1Click(TObject *Sender);
    void __fastcall Novhra1Click(TObject *Sender);
    void __fastcall PaintBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);

    void __fastcall Rada1Click(TObject *Sender);
    void __fastcall Tahzpt1Click(TObject *Sender);
    void __fastcall Tahvped1Click(TObject *Sender);
    
    
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall SpeedButton2Click(TObject *Sender);
    void __fastcall SpeedButton3Click(TObject *Sender);
    void __fastcall SpeedButton4Click(TObject *Sender);
    
    void __fastcall Vypnoutzapnout2Click(TObject *Sender);
    void __fastcall Uloit1Click(TObject *Sender);
    
    void __fastcall Nast1Click(TObject *Sender);
    void __fastcall SpeedButton3MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall SpeedButton3MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
    
    
    void __fastcall SpeedButton5Click(TObject *Sender);
    void __fastcall SpeedButton6Click(TObject *Sender);
    void __fastcall SpeedButton7Click(TObject *Sender);
    void __fastcall SpeedButton8Click(TObject *Sender);
    void __fastcall Pomoc1Click(TObject *Sender);
    void __fastcall SpeedButton9Click(TObject *Sender);
private:
public:
  __fastcall TFormular(TComponent* Owner);
  __fastcall virtual ~TFormular(void);
  THalma *halma;
};


//---------------------------------------------------------------------------
extern PACKAGE TFormular *Formular;
//---------------------------------------------------------------------------
#endif
