#include <vcl.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#include "Alloc.h"
#include "Hlavicka.h"
#include "Mozek.h"
#include "Hrac.h"
#include "Hlavni.h"
#define KROK 100 //zmena ohodnoceni pri ukonceni
#define ADAPTACE 14 //pocet kroku zamereni protihrace
//#define SADAPTACI
//#define LADENI

extern TStatusBar *sBar;

TMozek::TMozek(THraciPlan *hraciPlan_)
{
  randomize();
  urovenAktualni = uroven;
  hraciPlan = hraciPlan_;
  urovenAktualni->tahPrvni = zasobnikTahu;
  int i;
  for (i = 0; i < pocetPultahuMax; i++, urovenAktualni++)
  {
    urovenAktualni->hracKoncici = NULL;
    urovenAktualni->uzelProvizorni = new TUzelOhodnoceni;
    urovenAktualni->urovenIndex = i;
    urovenAktualni->vnoreni = 0;
  }
  for (i = 0; i < velikostZasobnikuTahu; i++)
    zasobnikTahu[i].uzel = new TUzelOhodnoceni;
}

TMozek::~TMozek()
{
  int i;
  urovenAktualni = uroven;
  for (i = 0; i < pocetPultahuMax; i++, urovenAktualni++)
    delete urovenAktualni->uzelProvizorni;
  for (i = 0; i < velikostZasobnikuTahu; i++)
    delete zasobnikTahu[i].uzel;
}

void TMozek::OhodnotitPozici(TUzelOhodnoceni *uzel)
{
  //zalezi na hracich ve hre, nikoli na tom hraci, ktery je na tahu
  urovenAktualni->variantaHlavniDelka = urovenAktualni->urovenIndex;
  switch (hraciPocet)
  {
    case 1:
      uzel->maticeHodnot[0][hracNaTahu->orientace] = hracNaTahu->OhodnoceniPozice();
      break;
    case 2:
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi;
      switch (hraciPocetStart)
      {
	case 3: //treti vrstvu je mozne vypocitat jen z prvni
	  uzel->maticeHodnot[0][hracA->orientace] = hracA->OhodnoceniPozice();
	  uzel->maticeHodnot[0][hracB->orientace] = hracB->OhodnoceniPozice();
	case 2: //neni treba pocitat prvni vrstvu
	  uzel->maticeHodnot[1][hracA->orientace] = hracA->OhodnoceniPozice() - hracB->OhodnoceniPozice();
	  uzel->maticeHodnot[1][hracB->orientace] = -uzel->maticeHodnot[1][hracA->orientace];
      }
      break;
    case 3://neni treba pocitat prvni a druhou vrstvu
     hracA = hracNaTahu;hracB = hracNaTahu->dalsi;hracC = hracB->dalsi;
     ohodnoceniPoziceA = hracA->OhodnoceniPozice();
     ohodnoceniPoziceB = hracB->OhodnoceniPozice();
     ohodnoceniPoziceC = hracC->OhodnoceniPozice();
     uzel->maticeHodnot[2][hracA->orientace] = 2 * ohodnoceniPoziceA
      - ohodnoceniPoziceB - ohodnoceniPoziceC;
     uzel->maticeHodnot[2][hracB->orientace] = 2 * ohodnoceniPoziceB
      - ohodnoceniPoziceA - ohodnoceniPoziceC;
     uzel->maticeHodnot[2][hracC->orientace] = 2 * ohodnoceniPoziceC
      - ohodnoceniPoziceA - ohodnoceniPoziceB;
  }
}

//prepocitavani se provadi po znovuvlozeni hrace hracNaTahu do hry
void TMozek::PrepocetOhodnoceni(TUzelOhodnoceni *uzel)//nezalezi na tom jaky hrac je na tahu
{
  switch(hraciPocet) //pocet hracu je ten, na ktery se je treba dostat
  {
    case 2: //prechod 1 -> 2
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi;
      switch (hraciPocetStart)
      {
	case 3: //treti vrstvu je mozne vypocitat jen z prvni
	  uzel->maticeHodnot[0][hracA->orientace] = hracA->OhodnoceniPozice();
	case 2: //neni treba pocitat prvni vrstvu
	  uzel->maticeHodnot[1][hracA->orientace] = hracA->OhodnoceniPozice() -
	    uzel->maticeHodnot[0][hracB->orientace];
	  uzel->maticeHodnot[1][hracB->orientace] =
	    -uzel->maticeHodnot[1][hracA->orientace];
      }
      break;
    case 3: //prechod 2 -> 3
      ohodnoceniPoziceA = hracA->OhodnoceniPozice();
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi; hracC = hracB->dalsi;
      uzel->maticeHodnot[2][hracA->orientace] = 2 * ohodnoceniPoziceA
      - uzel->maticeHodnot[0][hracB->orientace] - uzel->maticeHodnot[0][hracC->orientace];
      uzel->maticeHodnot[2][hracB->orientace] = 2 * uzel->maticeHodnot[0][hracB->orientace]
      - ohodnoceniPoziceA - uzel->maticeHodnot[0][hracC->orientace];
      uzel->maticeHodnot[2][hracC->orientace] = 2 * uzel->maticeHodnot[0][hracC->orientace]
      - ohodnoceniPoziceA - uzel->maticeHodnot[0][hracC->orientace];
  }
}

TOhodnoceni TMozek::Vykon(THrac *hrac)
{
  return (TOhodnoceni)(hrac->OhodnoceniPozice() - hrac->ohodnoceniPoziceStart) /
   urovenAktualni->urovenIndex;//Vykonana prace lomeno cas
}


void TMozek::OhodnotitPoziciVykonnostne(TUzelOhodnoceni *uzel)
{
  //zalezi na hracich ve hre, nikoli na tom hraci, ktery je na tahu
  urovenAktualni->variantaHlavniDelka = urovenAktualni->urovenIndex;
  switch (hraciPocet)
  {
    case 1:
      uzel->maticeHodnot[0][hracNaTahu->orientace] = Vykon(hracNaTahu);
      break;
    case 2:
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi;
      switch (hraciPocetStart)
      {
	case 3: //treti vrstvu je mozne vypocitat jen z prvni
	  uzel->maticeHodnot[0][hracA->orientace] = Vykon(hracA);
	  uzel->maticeHodnot[0][hracB->orientace] = Vykon(hracB);
	case 2: //neni treba pocitat prvni vrstvu
	  uzel->maticeHodnot[1][hracA->orientace] = Vykon(hracA) - Vykon(hracB);
	  uzel->maticeHodnot[1][hracB->orientace] = -uzel->maticeHodnot[1][hracA->orientace];
      }
      break;
    case 3://neni treba pocitat prvni a druhou vrstvu
     hracA = hracNaTahu;hracB = hracNaTahu->dalsi;hracC = hracB->dalsi;
     ohodnoceniPoziceA = Vykon(hracA);
     ohodnoceniPoziceB = Vykon(hracB);
     ohodnoceniPoziceC = Vykon(hracC);
     uzel->maticeHodnot[2][hracA->orientace] = 2 * ohodnoceniPoziceA
      - ohodnoceniPoziceB - ohodnoceniPoziceC;
     uzel->maticeHodnot[2][hracB->orientace] = 2 * ohodnoceniPoziceB
      - ohodnoceniPoziceA - ohodnoceniPoziceC;
     uzel->maticeHodnot[2][hracC->orientace] = 2 * ohodnoceniPoziceC
      - ohodnoceniPoziceA - ohodnoceniPoziceB;
  }
}

//prepocitavani se provadi po znovuvlozeni hrace hracNaTahu do hry
void TMozek::PrepocetOhodnoceniVykonnostne(TUzelOhodnoceni *uzel)//nezalezi na tom jaky hrac je na tahu
{
  switch(hraciPocet) //pocet hracu je ten, na ktery se je treba dostat
  {
    case 2: //prechod 1 -> 2
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi;
      switch (hraciPocetStart)
      {
	case 3: //treti vrstvu je mozne vypocitat jen z prvni
            //bez breaku, projde to
	  uzel->maticeHodnot[0][hracA->orientace] = Vykon(hracA);
	case 2: //neni treba pocitat prvni vrstvu
	  uzel->maticeHodnot[1][hracA->orientace] = Vykon(hracA) -
	    uzel->maticeHodnot[0][hracB->orientace];
	  uzel->maticeHodnot[1][hracB->orientace] =
	    -uzel->maticeHodnot[1][hracA->orientace];
      }
      break;
    case 3: //prechod 2 -> 3
      ohodnoceniPoziceA = Vykon(hracA);
      hracA = hracNaTahu; hracB = hracNaTahu->dalsi; hracC = hracB->dalsi;
      uzel->maticeHodnot[2][hracA->orientace] = 2 * ohodnoceniPoziceA
      - uzel->maticeHodnot[0][hracB->orientace] - uzel->maticeHodnot[0][hracC->orientace];
      uzel->maticeHodnot[2][hracB->orientace] = 2 * uzel->maticeHodnot[0][hracB->orientace]
      - ohodnoceniPoziceA - uzel->maticeHodnot[0][hracC->orientace];
      uzel->maticeHodnot[2][hracC->orientace] = 2 * uzel->maticeHodnot[0][hracC->orientace]
      - ohodnoceniPoziceA - uzel->maticeHodnot[0][hracC->orientace];
  }
}

//Vraci nejlepe ohodnoceny tah z dosud neprovedenych tahu
TTah *TMozek::VybratTah()
{
  TOhodnoceni hod = hraciPlan->ohodnoceniPoziceMin;//neudrzitelna hodnota
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    if (!tah->indikatorVyrazeni && hod <= tah->ohodnoceni)
      if (hod < tah->ohodnoceni || random(2))
      {
        tahVybrany = tah;
        hod = tah->ohodnoceni;
      }
  if (hod == hraciPlan->ohodnoceniPoziceMin) return NULL;
  tahVybrany->indikatorVyrazeni = true;
  return tahVybrany;
}

void TMozek::NegaceIndikatoruVyrazeni()
{
  //ty tahy co byli odseknuty jiz neuvazuji
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    tah->indikatorVyrazeni = !tah->indikatorVyrazeni;
}

TTah *TMozek::VybratTahASelektivita(int variantyPocet)
{
  TOhodnoceni hod = hraciPlan->ohodnoceniPoziceMin;//neudrzitelna hodnota
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    if (!tah->indikatorVyrazeni && hod <= tah->ohodnoceni)
      if (hod < tah->ohodnoceni || random(2))
      {
        tahVybrany = tah;
        hod = tah->ohodnoceni;
      }
  tahVybrany->indikatorVyrazeni = true;
  if (hod == hraciPlan->ohodnoceniPoziceMin) return NULL;
  if (variantyPocet != -1)
  {
    //snahu delime rovnostarsky
    tahVybrany->snaha = urovenAktualni->snaha / variantyPocet;
    return tahVybrany;
  }
  if (urovenAktualni->snaha < urovenAktualni->snahaSuma)
   return NULL;//nema smysl provest ani ohodnoceni
  urovenAktualni->snahaSuma += (tahVybrany->snaha < 1) ? 1 : tahVybrany->snaha;
  return tahVybrany;
}


bool TMozek::PlatiPodminkaOdseknuti()
{
  if (hraciPocet == 1) return false;
  TOhodnoceni suma = 0, hod;
  int i;
  THrac *hrac;
  for (i = 0, hrac = hracNaTahu; i < hraciPocet; i++,hrac = hrac->dalsi)
  {
    if ((hod = urovenAktualni->vektorMeznichHodnot[hrac->orientace]) == hraciPlan->ohodnoceniPoziceMin)
      return false;
    suma += hod;
  }
  return (suma >= 0) ? true : false;
}

TTah* TMozek::Transformace3na2hrace()
{
 TOhodnoceni ohodnoceniTahu[200];
 THrac *hrac[3];
 int i,j,jMax = 0;
 hloubkaMax = 4;
 if (hraciPocetStart < 3)
 {
   ProhledavaniStromuDoPevneHloubkySUzly();
   return &variantaHlavni[0][0];
 }
 //Hra tri hracu se rozdeli ne dve hry dvou hracu
 hrac[0] = hracNaTahu;
 hrac[1] = hracNaTahu->dalsi;
 hrac[2] = hrac[1]->dalsi;
 hraciPocet = hraciPocetStart = 2;
 for (i = 1; i < 3; i++)
 {
   hracNaTahu->dalsi = hrac[i];
   hrac[i]->dalsi = hracNaTahu;
   hracNaTahu->predchozi = hrac[i];
   hrac[i]->predchozi = hracNaTahu;
   urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
   hraciPlan->ohodnoceniPoziceMin;
   urovenAktualni->vektorMeznichHodnot[hrac[i]->orientace] =
   hraciPlan->ohodnoceniPoziceMin;
   ProhledavaniStromuDoPevneHloubkySUzly();
   j = 0;
   for (TTah *tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
   {
     if (i == 1) ohodnoceniTahu[j] = 0;
     ohodnoceniTahu[j] += tah->uzel->maticeHodnot[1][hracNaTahu->orientace];
     if (i == 2 && ohodnoceniTahu[jMax] < ohodnoceniTahu[j]) jMax = j;
     j++;
   }
 }
 //Navrat seznamu hracu do puvodniho stavu
 for (i = 0; i < 2; i++)
 {
   hrac[i]->dalsi = hrac[i + 1];
   hrac[i + 1]->predchozi = hrac[i];
 }
 hrac[0]->predchozi = hrac[2];
 hrac[2]->dalsi = hrac[0];
 return urovenAktualni->tahPrvni + jMax;
}

TTah *TMozek::VypocitatNejlepsiTah(THrac *hracNaTahu_,int metoda_)
{
  hracNaTahu = hracNaTahu_;
  if (hracNaTahu->JeChlivecekPlny())
    return NULL;
  strcpy(zprava,"");
  urovenAktualni = uroven;
  hraciPocetStart = 0;
  hracStart = hrac = hracNaTahu;
  TOhodnoceni v;
  char zpravaElement[100];
  //urceni poctu hracu ve hre
  THrac *hraci[3]; int i = 0;
  do
  {
     hraci[i] = hrac;
     i++;
     hraciPocetStart++;
     urovenAktualni->vektorMeznichHodnot[hrac->orientace] =
	   hraciPlan->ohodnoceniPoziceMin;
     hrac->ohodnoceniPoziceStart = hrac->OhodnoceniPozice();
     hrac = hrac->dalsi;
  } while(hrac != hracNaTahu);
  hraciPocet = hraciPocetStart;
  pozicePocetZkousene = 0;
  hloubkaMax = 0; hloubkaMin = pocetPultahuMax;
  if (metoda_ <= 5)//prohledavani do pevne hloubky
  {
    hloubkaMax = metoda_;
    ProhledavaniStromuDoPevneHloubky();
    return &variantaHlavni[0][0];
  }
  if (metoda_ >= 6 && metoda_ <= 9)//selektivni prohledavani
  {
    selektivita = (metoda_ % 2 + 1);//cim vyssi tim uzsi strom
    //TOhodnoceni snaha = 1000000 * selektivita;
    /*TOhodnoceni snaha = 10000 * selektivita;
    urovenAktualni->snaha = (metoda_ <= 7) ? snaha : 200 * snaha;*/
    urovenAktualni->snaha = (metoda_ <= 7) ? 1000 : 1000000;
    switch (hraciPocet)
    {
      case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
      break;
      case 3: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)2/3);
    }
    SelektivniProhledavaniStromu();
    return &variantaHlavni[0][0];
  }
  if (metoda_ >= 10 && metoda_ <= 13)//hierarchicke prohledavani
  {
    hierarchicnost = 0.05F;//kolikanasobnou snahu vyslu na
                           //ohodnoceni hran
    selektivita = (metoda_ % 2 + 1) * sqrt(hierarchicnost);
    urovenAktualni->snaha = (metoda_ <= 11) ? 1000 : 1000000;
    //urovenAktualni->snaha = 100000;
    //if (metoda_ >= 12) urovenAktualni->snaha *= 20;
    switch (hraciPocet)
    {
      case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
      break;
      case 3: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)2/3);
    }
    HierarchickeProhledavaniStromu(true);
    return &variantaHlavni[0][0];
  }
  //transformace ze 3 hracu na dva
  if (metoda_ == 14) return Transformace3na2hrace();
  //modelovani stromem hloubky 2 uvnitr stromu hloubky 4
  if (metoda_ == 15)
  {
    hrac = hracNaTahu->dalsi;
    while (hrac != hracNaTahu)
    {
      //Hrace modeluji stromem hloubky 2
      hrac->modelHloubka = 2;
      hrac = hrac->dalsi;
    }
    hloubkaMax = 4;
    ProhledavaniModelovanimStromemPevneHloubky();
    return &variantaHlavni[0][0];
  }
  //Adaptivni modelovani stromem pevne hloubky
  if (metoda_ == 16)
  {
    strcpy(zprava,"       Hloubka modelu:");
    hloubkaMax = 4;
    #ifdef SADAPTACI
    for (i = 1; i < hraciPocetStart; i++)
    {
      v = hraci[0]->ohodnoceniPozice_ + hraci[i]->ohodnoceniPozice_;
      if (v != 0)
      {
        v = (TOhodnoceni)(hraci[0]->ohodnoceniPozice_ - hraci[i]->ohodnoceniPozice_) / v;
        if (v < 0)  //protihrac je silnejsi
        {
          v = -0.2776F * pow(-v,0.201);
          hraci[i]->modelSlabsiPocet = 0;
        }
        else        //ja jsem silnejsi
        {
          v = 0.2776F * pow(v,0.201);
          hraci[i]->modelSlabsiPocet++;
        }
      } else
        hraci[i]->modelSlabsiPocet = 0;
      if (v == -1.0F)
        hraci[i]->modelHloubka = hloubkaMax;
      else
        if (hraci[i]->modelSlabsiPocet < ADAPTACE)
          hraci[i]->modelHloubka = (int)((TOhodnoceni)hloubkaMax * (1.0F - v) / (1.0F + v));
      sprintf(zpravaElement,"   hr. .%d - %d",hraci[i]->hracCislo + 1,hraci[i]->modelHloubka);
      strcat(zprava,zpravaElement);
      //jinak je protihrac dobre zameren a model netreba menit
    }
    sBar->SimpleText = AnsiString(sBar->SimpleText) + AnsiString(zprava);
    //hraci[0]->halma->Synchro(sBar->Repaint);
    #else
      hraci[1]->modelHloubka = 2;
    #endif
    ProhledavaniModelovanimStromemPevneHloubky();
    return &variantaHlavni[0][0];
  }
  //Adaptivni modelovani selektivnim stromem
  if (metoda_ == 17)
  {
    strcpy(zprava,"        Snaha modelu:");
    selektivita = 1;//cim vyssi tim uzsi strom
    urovenAktualni->snaha = 1000000;
    switch (hraciPocet)
    {
      case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
      break;
      case 3: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)2/3);
    }
    #ifdef SADAPTACI
    for (i = 1; i < hraciPocetStart; i++)
    {
      v = hraci[0]->ohodnoceniPozice_ + hraci[i]->ohodnoceniPozice_;
      if (v != 0)
      {
        v = (TOhodnoceni)(hraci[0]->ohodnoceniPozice_ - hraci[i]->ohodnoceniPozice_) / v;
        if (v < 0)  //protihrac je silnejsi
        {
          v = -0.2776F * pow(-v,0.201);
          hraci[i]->modelSlabsiPocet = 0;
        }
        else        //ja jsem silnejsi
        {
          v = 0.2776F * pow(v,0.201);
          hraci[i]->modelSlabsiPocet++;
        }
      } else
        hraci[i]->modelSlabsiPocet = 0;
      if (v == -1.0F)
        hraci[i]->modelSnaha = urovenAktualni->snaha;
      else
        if (hraci[i]->modelSlabsiPocet < ADAPTACE)
        {
          v = (1.0F - v) / (1.0F + v);
          hraci[i]->modelSnaha = pow(urovenAktualni->snaha,v);//to neni heuristika
        }
      sprintf(zpravaElement,"   hr. .%d - %d",hraci[i]->hracCislo + 1,(int)hraci[i]->modelSnaha);
      strcat(zprava,zpravaElement);
      //jinak je protihrac dobre zameren a model netreba menit
    }
    sBar->SimpleText = AnsiString(sBar->SimpleText) + AnsiString(zprava);
    #else
      hraci[1]->modelSnaha = 1000;
    #endif
    ProhledavaniModelovanimSelektivnimPodstromem();
    return &variantaHlavni[0][0];
  }
  //Adaptivni modelovani hierarch. prohledavanim
  if (metoda_ == 18)
  {
    hierarchicnost = 0.05F;//kolikanasobnou snahu vyslu na
                           //ohodnoceni hran
    selektivita = sqrt(hierarchicnost);
    urovenAktualni->snaha = 1000000;
    switch (hraciPocet)
    {
      case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
      break;
      case 3: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)2/3);
    }
    for (i = 1; i < hraciPocetStart; i++)
    {
      v = hraci[0]->ohodnoceniPozice_ + hraci[i]->ohodnoceniPozice_;
      if (v != 0)
      {
        v = (TOhodnoceni)(hraci[0]->ohodnoceniPozice_ - hraci[i]->ohodnoceniPozice_) / v;
        if (v < 0)  //protihrac je silnejsi
        {
          v = -0.2776F * pow(-v,0.201);
          hraci[i]->modelSlabsiPocet = 0;
        }
        else        //ja jsem silnejsi
        {
          v = 0.2776F * pow(v,0.201);
          hraci[i]->modelSlabsiPocet++;
        }
      } else
        hraci[i]->modelSlabsiPocet = 0;
      if (v == -1.0F)
        hraci[i]->modelSnaha = urovenAktualni->snaha;
      else
        if (hraci[i]->modelSlabsiPocet < ADAPTACE)
        {
          v = (1.0F - v) / (1.0F + v);
          hraci[i]->modelSnaha = pow(urovenAktualni->snaha,v);//to neni heuristika
        }
      sprintf(zpravaElement,"   hr. .%d - %d",hraci[i]->hracCislo + 1,(int)hraci[i]->modelSnaha);
      strcat(zprava,zpravaElement);
      //jinak je protihrac dobre zameren a model netreba menit
    }
    sBar->SimpleText = AnsiString(sBar->SimpleText) + AnsiString(zprava);
    hraci[1]->modelSnaha = 1000;
    ProhledavaniModelovanimHierarchickymPodstromem(true);
    return &variantaHlavni[0][0];
  }
  return NULL;
}

void TMozek::JednoducheOhodnoceniTahu()//Kdybych prevedl uplne ohodnoceni pozice,
				                       //dostal bych stejny vysledek
{                                      //Predstupen pro stepeni snahy
  int k = (hraciPocet == 1) ? 1 : hraciPocet - 1;
  TOhodnoceni oh = hracNaTahu->OhodnoceniPozice();
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
  {
    hracNaTahu->TahniFigurkou(tah->polickoStart,tah->polickoCil);
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hraciPocet > 1) hracNaTahu->ZaplnitChlivecek();
      hracNaTahu->ohodnoceniPozice += KROK *(pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
      tah->ohodnoceni = k * (hracNaTahu->OhodnoceniPozice() - oh);
      hracNaTahu->ohodnoceniPozice -= KROK *(pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
      if (hraciPocet > 1) hracNaTahu->ZaplnitChlivecekInverze();
    } else
      tah->ohodnoceni = k * (hracNaTahu->OhodnoceniPozice() - oh);
    hracNaTahu->TahniFigurkou(tah->polickoCil,tah->polickoStart);
  }
}

void TMozek::ProhledavaniStromuDoPevneHloubky()
{
  int i;
  TOhodnoceni hod;
  TUzelOhodnoceni *uzel;
  pozicePocetZkousene++;
  if (urovenAktualni->urovenIndex >= hloubkaMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    OhodnotitPozici(urovenAktualni->uzelProvizorni);
    return;
  }
  //generovani tahu
  urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
  (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
  #ifdef LADENI
  int tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
  #endif
  //toto nastaveni provizorniho uzlu je neudrzitelne
  urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace] =
    hraciPlan->ohodnoceniPoziceMin;
  while ((urovenAktualni->tah = VybratTah()) != NULL)
  {
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();
        hracNaTahu->ohodnoceniPozice += KROK *(hloubkaMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
	    urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
           hraciPlan->ohodnoceniPoziceMin;
	    //hracNaTahu = hracNaTahu->dalsi;
	    ProhledavaniStromuDoPevneHloubky();
        hraciPocet++;
	    urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
	    PrepocetOhodnoceni((urovenAktualni + 1)->uzelProvizorni);//Nutno az po znovuvlozeni hrace
        hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (hloubkaMax - urovenAktualni->urovenIndex);
        urovenAktualni++;
	    OhodnotitPozici(urovenAktualni->uzelProvizorni); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
	hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      //pri nalezeni lepsiho mezivysledku dojde pouze k prohozeni uzlu
      uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = (urovenAktualni + 1)->uzelProvizorni;
      (urovenAktualni + 1)->uzelProvizorni = uzel;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    ProhledavaniStromuDoPevneHloubky();
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = (urovenAktualni + 1)->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace])
    {
      //pri nalezeni lepsiho mezivysledku dojde pouze k prohozeni uzlu
      uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = (urovenAktualni + 1)->uzelProvizorni;
      (urovenAktualni + 1)->uzelProvizorni = uzel;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    if (urovenAktualni->urovenIndex + 1 >= hloubkaMax) return;
  }
  return;
}
void TMozek::ProhledavaniStromuDoPevneHloubkySUzly()
{
  int i;
  TOhodnoceni hod,hodNejlepsi;
  TUzelOhodnoceni *uzel;
  urovenAktualni->tahNejlepsi = NULL;
  pozicePocetZkousene++;
  if (urovenAktualni->urovenIndex >= hloubkaMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    OhodnotitPozici(urovenAktualni->uzelProvizorni);
    //uzelProvizorni slouzi pouze pro ohodnoceni listu
    return;
  }
  //generovani tahu
  urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
  (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
  #ifdef LADENI
  int tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
  #endif
  //toto nastaveni provizorniho uzlu je neudrzitelne
  //urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace] =
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  while ((urovenAktualni->tah = VybratTah()) != NULL)
  {
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();
        hracNaTahu->ohodnoceniPozice += KROK *(hloubkaMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
	    urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
           hraciPlan->ohodnoceniPoziceMin;
	    //hracNaTahu = hracNaTahu->dalsi;
	    ProhledavaniStromuDoPevneHloubkySUzly();
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
        hraciPocet++;
	    urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
	    PrepocetOhodnoceni(urovenAktualni->tah->uzel);//Nutno az po znovuvlozeni hrace
        hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (hloubkaMax - urovenAktualni->urovenIndex);
        urovenAktualni++;
	    OhodnotitPozici((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
	hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    ProhledavaniStromuDoPevneHloubkySUzly();
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	    urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    if (urovenAktualni->urovenIndex + 1 >= hloubkaMax) return;
  }
  return;
}

void TMozek::SelektivniProhledavaniStromu()
{
  int i;
  TOhodnoceni hod;
  TUzelOhodnoceni *uzel;
  pozicePocetZkousene++;
  if (urovenAktualni->snaha <= 1 || urovenAktualni->urovenIndex + 1  >= pocetPultahuMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    if (hloubkaMin > urovenAktualni->urovenIndex)
      hloubkaMin = urovenAktualni->urovenIndex;
    if (hloubkaMax < urovenAktualni->urovenIndex)
      hloubkaMax = urovenAktualni->urovenIndex;
    OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni);
    return;
  }
  //generovani tahu
  urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
  (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
  urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
  //JednoducheOhodnoceniTahu();
  //RozdelitSnahu(selektivita * 100 / (urovenAktualni->snaha + 50));
  //RozdelitSnahu(selektivita / sqrt(urovenAktualni->snaha));
  //RozdelitSnahu(selektivita * pow(3,(TOhodnoceni)1 - urovenAktualni->snaha / 50));
  TOhodnoceni wr = (TOhodnoceni)1 - (TOhodnoceni)hracNaTahu->ohodnoceniPozice / hracNaTahu->hraciPlan->ohodnoceniPoziceMax;
  RozdelitSnahu(selektivita * wr * 30 * 4 / (urovenAktualni->snaha * 3 + 30));
  urovenAktualni->snahaSuma = 1;//1 kvuli srovnavani se snahou
  //toto nastaveni provizorniho uzlu je neudrzitelne
  urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace] =
    hraciPlan->ohodnoceniPoziceMin;
  while ((urovenAktualni->tah = VybratTahASelektivita(-1)) != NULL)
  {
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    bool poprve = true;
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();//ohodnoceni je mozne zvysit az po te
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
        urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
		    hraciPlan->ohodnoceniPoziceMin;
     	//hracNaTahu = hracNaTahu->dalsi;
	    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
        switch (hraciPocet)
        { //2->1
          case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
          break;
          //3->2
          case 2: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)3/2);
        }
	    SelektivniProhledavaniStromu();
	    hraciPocet++;
        PrepocetOhodnoceniVykonnostne(urovenAktualni->uzelProvizorni);//Nutno az po znovuvlozeni hrace
        urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni++;
	    OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      //pri nalezeni lepsiho mezivysledku dojde pouze k prohozeni uzlu
      uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = (urovenAktualni + 1)->uzelProvizorni;
      (urovenAktualni + 1)->uzelProvizorni = uzel;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
    SelektivniProhledavaniStromu();
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = (urovenAktualni + 1)->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace])
    {
      //pri nalezeni lepsiho mezivysledku dojde pouze k prohozeni uzlu
      uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = (urovenAktualni + 1)->uzelProvizorni;
      (urovenAktualni + 1)->uzelProvizorni = uzel;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	     urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    if (poprve && urovenAktualni->tah->snaha <= 1) return; //ostatni tahy jsou urcite horsi
    poprve = false;
  }
  return;
}


void TMozek::SelektivniProhledavaniStromuSUzly()
{
  int i;
  TOhodnoceni hod,hodNejlepsi;
  TUzelOhodnoceni *uzel;
  urovenAktualni->tahNejlepsi = NULL;
  pozicePocetZkousene++;
  if (urovenAktualni->snaha <= 1 || urovenAktualni->urovenIndex + 1  >= pocetPultahuMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    if (hloubkaMin > urovenAktualni->urovenIndex)
      hloubkaMin = urovenAktualni->urovenIndex;
    if (hloubkaMax < urovenAktualni->urovenIndex)
      hloubkaMax = urovenAktualni->urovenIndex;
    OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni);
    return;
  }
  //generovani tahu
  urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
  (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
  urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
  //JednoducheOhodnoceniTahu();
  //RozdelitSnahu(selektivita / urovenAktualni->snaha);
  TOhodnoceni wr = (TOhodnoceni)1 - (TOhodnoceni)hracNaTahu->ohodnoceniPozice / hraciPlan->ohodnoceniPoziceMax;
  RozdelitSnahu(selektivita * wr * 30 * 4 / (urovenAktualni->snaha * 3 + 30));
  urovenAktualni->snahaSuma = 1;//1 kvuli srovnavani se snahou
  //toto nastaveni provizorniho uzlu je neudrzitelne
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  while ((urovenAktualni->tah = VybratTahASelektivita(-1)) != NULL)
  {
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    bool poprve = true;
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();//ohodnoceni je mozne zvysit az po te
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
        urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
		    hraciPlan->ohodnoceniPoziceMin;
     	//hracNaTahu = hracNaTahu->dalsi;
	    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
        switch (hraciPocet)
        { //2->1
          case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
          break;
          //3->2
          case 2: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)3/2);
        }
	    SelektivniProhledavaniStromuSUzly();
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
	    hraciPocet++;
        PrepocetOhodnoceniVykonnostne((urovenAktualni - 1)->tah->uzel);//Nutno az po znovuvlozeni hrace
        urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni++;
	    OhodnotitPoziciVykonnostne((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
    SelektivniProhledavaniStromuSUzly();
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	     urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    if (poprve && urovenAktualni->tah->snaha <= 1) return; //ostatni tahy jsou urcite horsi
    poprve = false;
  }
  return;
}
bool TMozek::HierarchickeProhledavaniStromu(bool ohodnotitPozici)
{
  int i;
  TOhodnoceni hod,hodNejlepsi;
  TUzelOhodnoceni *uzel;
  pozicePocetZkousene++;
  if (ohodnotitPozici) //Ohodnoceni pozice
  {
    urovenAktualni->tahNejlepsi = NULL;
    if (urovenAktualni->snaha <= 1 || urovenAktualni->urovenIndex + 1  >= pocetPultahuMax)
    {
      if (hloubkaMax < urovenAktualni->urovenIndex)
        hloubkaMax = urovenAktualni->urovenIndex;
      OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni);
      return false;
    }
  }
  else //Ohodnoceni vsech tahu
    if (urovenAktualni->snaha <= 1)
    {
      //ulozeni odsekavajicich meznich hodnot
      for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      {
       urovenAktualni->vektorMeznichHodnot_[hracNaTahu->orientace] =
	   urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace];
       /*urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
        hraciPlan->ohodnoceniPoziceMin;*/
      }
      //generovani tahu, provizorni ohodnoceni jiz mam z generovani
      urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
      (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
      urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
      return true;
    }
  TOhodnoceni snaha = urovenAktualni->snaha;
  urovenAktualni->snaha = urovenAktualni->snaha * hierarchicnost;
  urovenAktualni->vnoreni++;
  bool ohodnoceno = HierarchickeProhledavaniStromu(false);//Provizorni ohodnoceni vetvi (tahu)
                                   //Zustavame na stejne urovni
  urovenAktualni->vnoreni--;
  if (!ohodnotitPozici && urovenAktualni->tahyPocet >= snaha) return ohodnoceno;
  //nacteni odsekavajicich meznich hodnot
  for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
    urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
     urovenAktualni->vektorMeznichHodnot_[hracNaTahu->orientace];
  if (!ohodnoceno)
  {
    //PrevodUzluNaOhodnoceni();
    PrevodUzluNaOhodnoceniHier();
    NegaceIndikatoruVyrazeni();
  }
  urovenAktualni->snaha = snaha;
  RozdelitSnahu(selektivita);
  urovenAktualni->snahaSuma = 1;//1 kvuli srovnavani se snahou
  //toto nastaveni provizorniho uzlu je neudrzitelne
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  bool poprve = true;
  while ((urovenAktualni->tah = VybratTahASelektivita(-1)) != NULL)
  {
    TOhodnoceni snahaSuma = urovenAktualni->snahaSuma;
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();//ohodnoceni je mozne zvysit az po te
	hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
	    urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
		    hraciPlan->ohodnoceniPoziceMin;
	    //hracNaTahu = hracNaTahu->dalsi;
	    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
        switch (hraciPocet)
        { //2->1
          case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
          break;
          //3->2
          case 2: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)3/2);
        }
	    HierarchickeProhledavaniStromu(true);
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
	    hraciPocet++;
        urovenAktualni--;
        PrepocetOhodnoceni(urovenAktualni->tah->uzel);//Nutno az po znovuvlozeni hrace
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
	hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
	hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni++;
	    OhodnotitPoziciVykonnostne((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
	hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return false;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
    HierarchickeProhledavaniStromu(true);
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }

    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	    urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti()) return false;
      }
    }
    if (poprve && urovenAktualni->tah->snaha <= 1) return false; //ostatni tahy jsou urcite horsi
    urovenAktualni->snahaSuma = snahaSuma;
    poprve = false;
  }
  return false;
}


void TMozek::ProhledavaniModelovanimStromemPevneHloubky()
{
  int i;
  TOhodnoceni hod,hodNejlepsi;
  TUzelOhodnoceni *uzel;
  urovenAktualni->tahNejlepsi = NULL;
  pozicePocetZkousene++;
  if (urovenAktualni->urovenIndex >= hloubkaMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    OhodnotitPozici(urovenAktualni->uzelProvizorni);
    //uzelProvizorni slouzi pouze pro ohodnoceni listu
    return;
  }
  int hloubkaMax_;
  int variantyModeluPocet;//kolik vetvi jeste vyzkousim
  int hloubkaMaxNova = hracNaTahu->modelHloubka + urovenAktualni->urovenIndex;
  if (hracNaTahu != hracStart && hloubkaMaxNova < hloubkaMax)
  {
    hloubkaMax_ = hloubkaMax;
    hloubkaMax = hloubkaMaxNova;
    ProhledavaniStromuDoPevneHloubkySUzly();
    //znovu nastaveni odsekavajicich meznich hodnot
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hloubkaMax = hloubkaMax_;
    //Tady se vygeneruji tahy
    PrevodUzluNaOhodnoceni();
    NegaceIndikatoruVyrazeni();
    variantyModeluPocet = 1;
    //variantyModeluPocet = hloubkaMax - urovenAktualni->urovenIndex;
  } else
  {
    //generovani tahu
    urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
    (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
    urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
    variantyModeluPocet = -1;
  }
  //toto nastaveni provizorniho uzlu je neudrzitelne
  //urovenAktualni->uzelProvizorni->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace] =
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  while ((urovenAktualni->tah = VybratTah()) != NULL)
  {
    if (variantyModeluPocet > 0) variantyModeluPocet--;
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();
        hracNaTahu->ohodnoceniPozice += KROK *(hloubkaMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
	    urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
           hraciPlan->ohodnoceniPoziceMin;
	    //hracNaTahu = hracNaTahu->dalsi;
        ProhledavaniModelovanimStromemPevneHloubky();
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
        hraciPocet++;
	    urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
	    PrepocetOhodnoceni(urovenAktualni->tah->uzel);//Nutno az po znovuvlozeni hrace
        hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (hloubkaMax - urovenAktualni->urovenIndex);
        urovenAktualni++;
	    OhodnotitPozici((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
	hracNaTahu->ohodnoceniPozice -= KROK * (hloubkaMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    ProhledavaniModelovanimStromemPevneHloubky();
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	    urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    //Jsem-li na konci stromu, pak jsem prave vyzkousel neklepsi tah
    if (urovenAktualni->urovenIndex + 1 >= hloubkaMax) return;
    //Ostani vetve odseknu
    if (variantyModeluPocet == 0) return;
  }
  return;
}

void TMozek::ProhledavaniModelovanimSelektivnimPodstromem()
{
  int i;
  TOhodnoceni hod,hodNejlepsi,snaha;
  TUzelOhodnoceni *uzel;
  urovenAktualni->tahNejlepsi = NULL;
  pozicePocetZkousene++;
  if (urovenAktualni->snaha <= 1 || urovenAktualni->urovenIndex + 1  >= pocetPultahuMax)
  {
    //Je treba ohodnotit list herniho stromu, nikoli jej expandovat.
    if (hloubkaMin > urovenAktualni->urovenIndex)
      hloubkaMin = urovenAktualni->urovenIndex;
    if (hloubkaMax < urovenAktualni->urovenIndex)
      hloubkaMax = urovenAktualni->urovenIndex;
    OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni);
    return;
  }
  int variantyModeluPocet;//kolik vetvi jeste vyzkousim
  if (hracNaTahu != hracStart &&
      40.0F * hracNaTahu->modelSnaha < urovenAktualni->snaha)
  {
    snaha = urovenAktualni->snaha;
    urovenAktualni->snaha = hracNaTahu->modelSnaha;
    //selektivni prohledavani vygeneruje tahy
    //netreba stepeni snahy
    SelektivniProhledavaniStromuSUzly();
    //znovu nastaveni odsekavajicich meznich hodnot
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    urovenAktualni->snaha = snaha - hracNaTahu->modelSnaha;
    //Tady se vygeneruji tahy
    PrevodUzluNaOhodnoceniHier();
    NegaceIndikatoruVyrazeni();
    variantyModeluPocet = 1;
    //variantyModeluPocet = hloubkaMax - urovenAktualni->urovenIndex;
  } else
  {
    //generovani tahu
    urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
    (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
    urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
    variantyModeluPocet = -1;
    TOhodnoceni wr = (TOhodnoceni)1 - (TOhodnoceni)hracNaTahu->ohodnoceniPozice / hraciPlan->ohodnoceniPoziceMax;
    RozdelitSnahu(selektivita * wr * 30 * 4 / (urovenAktualni->snaha * 3 + 30));
  }
  urovenAktualni->snahaSuma = 1;//1 kvuli srovnavani se snahou
  //toto nastaveni provizorniho uzlu je neudrzitelne
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  int variantyModeluPocet_ = variantyModeluPocet;
  while ((urovenAktualni->tah = VybratTahASelektivita(variantyModeluPocet_)) != NULL)
  {
    if (variantyModeluPocet > 0) variantyModeluPocet--;
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    bool poprve = true;
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();//ohodnoceni je mozne zvysit az po te
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
        urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
		    hraciPlan->ohodnoceniPoziceMin;
     	//hracNaTahu = hracNaTahu->dalsi;
	    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
	    ProhledavaniModelovanimSelektivnimPodstromem();
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
	    hraciPocet++;
        PrepocetOhodnoceniVykonnostne((urovenAktualni - 1)->tah->uzel);//Nutno az po znovuvlozeni hrace
        urovenAktualni--;
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
        hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni++;
	    OhodnotitPoziciVykonnostne((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
        hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
    ProhledavaniModelovanimSelektivnimPodstromem();
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	     urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti())
	     return;
      }
    }
    if (poprve && urovenAktualni->tah->snaha <= 1) return; //ostatni tahy jsou urcite horsi
    poprve = false;
    //Ostani vetve odseknu
    if (variantyModeluPocet == 0) return;
  }
  return;
}

bool TMozek::ProhledavaniModelovanimHierarchickymPodstromem(bool ohodnotitPozici)
{
  int i;
  TOhodnoceni hod,hodNejlepsi;
  TUzelOhodnoceni *uzel;
  pozicePocetZkousene++;
  if (ohodnotitPozici) //Ohodnoceni pozice
  {
    urovenAktualni->tahNejlepsi = NULL;
    if (urovenAktualni->snaha <= 1 || urovenAktualni->urovenIndex + 1  >= pocetPultahuMax)
    {
      if (hloubkaMax < urovenAktualni->urovenIndex)
        hloubkaMax = urovenAktualni->urovenIndex;
      OhodnotitPoziciVykonnostne(urovenAktualni->uzelProvizorni);
      return false;
    }
  }
  else //Ohodnoceni vsech tahu
    if (urovenAktualni->snaha <= 1)
    {
      //ulozeni odsekavajicich meznich hodnot
      for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      {
       urovenAktualni->vektorMeznichHodnot_[hracNaTahu->orientace] =
	   urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace];
       /*urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
        hraciPlan->ohodnoceniPoziceMin;*/
      }
      //generovani tahu, provizorni ohodnoceni jiz mam z generovani
      urovenAktualni->tahPosledni = hracNaTahu->GenerovatTahy(urovenAktualni->tahPrvni);
      (urovenAktualni + 1)->tahPrvni = urovenAktualni->tahPosledni;
      urovenAktualni->tahyPocet = urovenAktualni->tahPosledni - urovenAktualni->tahPrvni;
      return true;
    }
  int variantyModeluPocet;//kolik vetvi jeste vyzkousim
  TOhodnoceni snaha;
  if (hracNaTahu != hracStart &&    //je vhodne modelovat ?
      40.0F * hracNaTahu->modelSnaha < urovenAktualni->snaha)
  {
    snaha = urovenAktualni->snaha;
    urovenAktualni->snaha = hracNaTahu->modelSnaha;
    //hierarchicke prohledavani vygeneruje tahy
    //netreba stepeni snahy
    HierarchickeProhledavaniStromu(true); //modelovani
    //znovu nastaveni odsekavajicich meznich hodnot
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    urovenAktualni->snaha = snaha - hracNaTahu->modelSnaha;
    //Tady se vygeneruji tahy
    PrevodUzluNaOhodnoceniHier();
    NegaceIndikatoruVyrazeni();
    variantyModeluPocet = 1;
    //variantyModeluPocet = hloubkaMax - urovenAktualni->urovenIndex;
  } else
  {
    snaha = urovenAktualni->snaha;
    urovenAktualni->snaha = urovenAktualni->snaha * hierarchicnost;
    urovenAktualni->vnoreni++;
    bool ohodnoceno = HierarchickeProhledavaniStromu(false);//Provizorni ohodnoceni vetvi (tahu)
                                   //Zustavame na stejne urovni
    urovenAktualni->vnoreni--;
    if (!ohodnotitPozici && urovenAktualni->tahyPocet >= snaha) return ohodnoceno;
    //nacteni odsekavajicich meznich hodnot
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
       urovenAktualni->vektorMeznichHodnot_[hracNaTahu->orientace];
    if (!ohodnoceno)
    {
      //PrevodUzluNaOhodnoceni();
      PrevodUzluNaOhodnoceniHier();
      NegaceIndikatoruVyrazeni();
    }
    urovenAktualni->snaha = snaha;
    RozdelitSnahu(selektivita);
  }
  urovenAktualni->snahaSuma = 1;//1 kvuli srovnavani se snahou
  //toto nastaveni provizorniho uzlu je neudrzitelne
  hodNejlepsi = hraciPlan->ohodnoceniPoziceMin;
  bool poprve = true;
  int variantyModeluPocet_ = variantyModeluPocet;
  while ((urovenAktualni->tah = VybratTahASelektivita(variantyModeluPocet_)) != NULL)
  {
    if (variantyModeluPocet > 0) variantyModeluPocet--;
    TOhodnoceni snahaSuma = urovenAktualni->snahaSuma;
    #ifdef LADENI
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #else
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoStart,urovenAktualni->tah->polickoCil);
    #endif
    //ohodnoceni tahu lze ocekavat o uroven nize
    if (hracNaTahu->JeChlivecekPlny())//byl proveden zaverecny tah
    {
      //tah hrace byl proveden, hrac dosahl konce a muze byt preskocen
      if (hracNaTahu != hracStart)
      {
	    //preskoceni hrace
	    hracNaTahu->predchozi->dalsi = hracNaTahu->dalsi;
	    hracNaTahu->dalsi->predchozi = hracNaTahu->predchozi;
	    hracNaTahu->ZaplnitChlivecek();//ohodnoceni je mozne zvysit az po te
	hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni->hracKoncici = hracNaTahu;
	    hraciPocet--;
	    urovenAktualni++;
	    //nastaveni odsekavajicich meznich hodnot o uroven nize na minimum
	    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
	      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
		    hraciPlan->ohodnoceniPoziceMin;
	    //hracNaTahu = hracNaTahu->dalsi;
	    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
        switch (hraciPocet)
        { //2->1
          case 1: urovenAktualni->snaha = sqrt(urovenAktualni->snaha);
          break;
          //3->2
          case 2: urovenAktualni->snaha = pow(urovenAktualni->snaha,(TOhodnoceni)3/2);
        }
	    ProhledavaniModelovanimHierarchickymPodstromem(true);
        //Zamena uzlu
        uzel = (urovenAktualni - 1)->tah->uzel;
        if (urovenAktualni->tahNejlepsi != NULL)
        {
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
          urovenAktualni->tahNejlepsi->uzel = uzel;
        } else
        {
          //o uroven nize byl list
          (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
          urovenAktualni->uzelProvizorni = uzel;
        }
	    hraciPocet++;
        urovenAktualni--;
        PrepocetOhodnoceni(urovenAktualni->tah->uzel);//Nutno az po znovuvlozeni hrace
	    //navraceni hrace do hry
	    hracNaTahu = urovenAktualni->hracKoncici;
	    hracNaTahu->predchozi->dalsi = hracNaTahu;
	    hracNaTahu->dalsi->predchozi = hracNaTahu;
	hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
	    hracNaTahu->ZaplnitChlivecekInverze();
	    urovenAktualni->hracKoncici = NULL;
      }
      else
      {
	hracNaTahu->ohodnoceniPozice += KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);//volim nejkratsi cestu k zakonceni
	    urovenAktualni++;
	    OhodnotitPoziciVykonnostne((urovenAktualni - 1)->tah->uzel); //posledni hrac ukoncil hru, netreba jej preskakovat
	    urovenAktualni--;
	hracNaTahu->ohodnoceniPozice -= KROK * (pocetPultahuMax - urovenAktualni->urovenIndex);
      }
      #ifdef LADENI
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #else
      //aplikovani inverzni operace
      hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
      #endif
      //neexistuje dalsi zpusob zakonceni
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      return false;
    }
    urovenAktualni++;
    //propagace odsekavajicich meznich hodnot o uroven nize
    for (i = 0; i < hraciPocet; i++,hracNaTahu = hracNaTahu->dalsi)
      urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] =
	(urovenAktualni - 1)->vektorMeznichHodnot[hracNaTahu->orientace];
    hracNaTahu = hracNaTahu->dalsi;
    urovenAktualni->snaha = (urovenAktualni - 1)->tah->snaha;
    ProhledavaniModelovanimHierarchickymPodstromem(true);
    //Zamena uzlu
    uzel = (urovenAktualni - 1)->tah->uzel;
    if (urovenAktualni->tahNejlepsi != NULL)
    {
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->tahNejlepsi->uzel;
      urovenAktualni->tahNejlepsi->uzel = uzel;
    } else
    {
      //o uroven nize byl list
      (urovenAktualni - 1)->tah->uzel = urovenAktualni->uzelProvizorni;
      urovenAktualni->uzelProvizorni = uzel;
    }
    hracNaTahu = hracNaTahu->predchozi;
    urovenAktualni--;
    #ifdef LADENI
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkouVykresli(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #else
    //aplikovani inverzni operace
    hracNaTahu->TahniFigurkou(urovenAktualni->tah->polickoCil,urovenAktualni->tah->polickoStart);
    #endif
    //obdrzel jsem ohodnoceni tahu, ktere se nachazi o uroven nize
    if ((hod = urovenAktualni->tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace]) >
      hodNejlepsi)
    {
      hodNejlepsi = hod;
      urovenAktualni->tahNejlepsi = urovenAktualni->tah;
      RegistraceLepsihoTahu();
      //je treba nastavit vetsi mezni hodnotu (, ktera slouzi k odseknuti) ?
      if (hod > urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace])
      {
	    urovenAktualni->vektorMeznichHodnot[hracNaTahu->orientace] = hod;
	    //plati-li podminka odseknuti, nemusim zkouset dalsi tahy
	    //na urovni vyhodnocovat
	    if (PlatiPodminkaOdseknuti()) return false;
      }
    }
    if (poprve && urovenAktualni->tah->snaha <= 1) return false; //ostatni tahy jsou urcite horsi
    urovenAktualni->snahaSuma = snahaSuma;
    poprve = false;
    //Ostani vetve odseknu
    if (variantyModeluPocet == 0) return false;
  }
  return false;
}

void TMozek::RegistraceLepsihoTahu()
{
  TUrovenStromu *urovenNize = urovenAktualni + 1;
  //byl nalezen lepsi tah, ktery je treba zahrnout do hlavni varianty
  int urovenIndex1 = urovenAktualni->urovenIndex;
  int urovenIndex2 = urovenNize->urovenIndex;
  variantaHlavni[urovenIndex1][urovenIndex1].polickoStart =
    urovenAktualni->tah->polickoStart;
  variantaHlavni[urovenIndex1][urovenIndex1].polickoCil =
    urovenAktualni->tah->polickoCil;
  urovenAktualni->variantaHlavniDelka = urovenNize->variantaHlavniDelka;
  for (int i = urovenIndex2; i < urovenNize->variantaHlavniDelka; i++)
  {
    variantaHlavni[i][urovenIndex1].polickoStart =
      variantaHlavni[i][urovenIndex2].polickoStart;
    variantaHlavni[i][urovenIndex1].polickoCil =
      variantaHlavni[i][urovenIndex2].polickoCil;
  }
}

void TMozek::PrevodUzluNaOhodnoceni()
{
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    tah->ohodnoceni =
      tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace];
}

void TMozek::PrevodUzluNaOhodnoceniHier()
{
  TOhodnoceni hod = urovenAktualni->urovenIndex * urovenAktualni->tahNejlepsi->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace];
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    tah->ohodnoceni =
      tah->uzel->maticeHodnot[hraciPocet - 1][hracNaTahu->orientace] * (urovenAktualni->urovenIndex + 1) - hod;
}

void TMozek::RozdelitSnahu(TOhodnoceni k)//Stepeni snahy na podsnahy
{
  TTah *tah;
  TOhodnoceni suma = 0,ohodnoceniMax = urovenAktualni->tahPrvni->ohodnoceni;
  //Nalezeni max. ohodnoceni proti preteceni
  for (tah = urovenAktualni->tahPrvni + 1; tah != urovenAktualni->tahPosledni; tah++)
    if (tah->ohodnoceni > ohodnoceniMax) ohodnoceniMax = tah->ohodnoceni;
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    suma += tah->snaha =
  exp(k * (tah->ohodnoceni - ohodnoceniMax));
  suma = (urovenAktualni->snaha - 1) / suma; //odtud snaha je pocet uzlu ve stromu
  for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    tah->snaha *= suma;
  /*for (tah = urovenAktualni->tahPrvni; tah != urovenAktualni->tahPosledni; tah++)
    tah->snaha = urovenAktualni->snaha / urovenAktualni->tahyPocet;*/
}
