//---------------------------------------------------------------------------
#ifndef MozekH
#define MozekH
//---------------------------------------------------------------------------
#include "Policko.h"
#include "Plan.h"

struct TUzelOhodnoceni{
  TOhodnoceni maticeHodnot[3][3]; /*   A        B      .
						      A-B      B-A     .
						    2A-B-C   2B-A-C  2C-A-B*/
};

struct TTah{
  bool indikatorVyrazeni;  //slouzi pro vyrazeni pri vyberu tahu k expanzi
  //float vaha;
  TPolicko *polickoStart;
  TPolicko *polickoCil;
  TOhodnoceni ohodnoceni;//element vektoru zisku nalezici hraci, slouzi
			 //pro stepeni snahy a razeni tahu
  TOhodnoceni snaha,snahaStara;
  TUzelOhodnoceni *uzel;
};


struct TUrovenStromu{
TTah *tahNejlepsi;
TTah *tahPrvni,*tahPosledni;     //ukazatel na prvni a posledni tah v zasobniku tahu
int tahyPocet;                   //pocet tahu v zasobniku tahu
TUzelOhodnoceni *uzelProvizorni; //naleznu-li uzel s lepsim ohodnocenim
				 //dojde pouze zamene s uzlem o uroven
				 //jednu uroven nize
//TUzelOhodnoceni *uzelProvizorni_;//pri hierarch. prohledavani ukazuje na uzel
                                 //nejlepsiho tahu
TOhodnoceni vektorMeznichHodnot[3];//hodnoty alfa, beta, gama
TOhodnoceni vektorMeznichHodnot_[3];//slouzi pro uchovani meznich hodnot
THrac *hracKoncici;
TTah *tah;
int urovenIndex; //urovne jsou cislovany od nuly
int variantaHlavniDelka;
TOhodnoceni snaha; //odpovida poctu zkoumanych pozic v podstromu bez vyhodnoceni
	     //efektu prorezavani. Ve skutecnosti tedy projdu mene pozic.
	     //To je nevyhoda protihrace, ze neprovadi prorezavani, ne moje.
	     //usili neni tedy meritkem casu vypoctu
TOhodnoceni snahaSuma;//nacita snahu. Je-li mensi nez 1 nacita se 1.
int vnoreni;//uroven vnoreni pri hierarchickem prohlubovani
};

struct TMozek{
private:
  THrac *hracNaTahu, *hracA, *hracB, *hracC, *hrac;
  TOhodnoceni ohodnoceniPoziceA, ohodnoceniPoziceB, ohodnoceniPoziceC;
  int hloubkaMax,hloubkaMin;
  TOhodnoceni selektivita; //cim vetsi, tim uzzsi podstrom prohledavam
  TOhodnoceni hierarchicnost; //kolikrat mensi snaha bude vynalozena na
                              //provizorni ohodnoceni
  TTah variantaHlavni[pocetPultahuMax][pocetPultahuMax];
  int hraciPocetStart,hraciPocet;
  long int pozicePocetZkousene;
  THrac *hracStart;
  TTah zasobnikTahu[velikostZasobnikuTahu], *tah, *tahVybrany;
  TUrovenStromu uroven[pocetPultahuMax];
  TUrovenStromu *urovenAktualni;
  void VygenerovatTahy();
  bool PlatiPodminkaOdseknuti();
  void OhodnotitPozici(TUzelOhodnoceni *uzel);
  void PrepocetOhodnoceni(TUzelOhodnoceni *uzel);
  TOhodnoceni Vykon(THrac *hrac);
  void OhodnotitPoziciVykonnostne(TUzelOhodnoceni *uzel);
  void PrepocetOhodnoceniVykonnostne(TUzelOhodnoceni *uzel);
  TTah *VybratTah();
  TTah *VybratTahASelektivita(int variantyPocet);
  void NegaceIndikatoruVyrazeni();
  void RegistraceLepsihoTahu();
  void PrevodUzluNaOhodnoceniHier();
  void RozdelitSnahu(TOhodnoceni k);//k - koeficient selektivity
  void ProhledavaniStromuDoPevneHloubky();
  void ProhledavaniStromuDoPevneHloubkySUzly();
  void SelektivniProhledavaniStromu();
  void SelektivniProhledavaniStromuSUzly();
  bool HierarchickeProhledavaniStromu(bool ohodnotitPozici);
  void ProhledavaniModelovanimStromemPevneHloubky();
  void ProhledavaniModelovanimSelektivnimPodstromem();
  bool ProhledavaniModelovanimHierarchickymPodstromem(bool ohodnotitPozici);
  void JednoducheOhodnoceniTahu();
  void PrevodUzluNaOhodnoceni();
  TTah* Transformace3na2hrace();
public:
  char zprava[200];
  THraciPlan *hraciPlan;
  TTah *VypocitatNejlepsiTah(THrac *hracNaTahu_,int metoda_);
  TMozek(THraciPlan *hraciPlan_);
  ~TMozek();
};

//---------------------------------------------------------------------------
#endif