#include <vcl.h>
#include <Math.h>
#include "Hlavicka.h"
#include "Policko.h"
#include "Hrac.h"
#include "Plan.h"

extern int krouzek_r;  //polomer policka
extern int krouzek_rm; //figurka je znazornena krouzkem s timto polomerem
extern float kx;       //zkresleni souradnic ve smeru x
extern int rozmer;     //rozmer planu
extern int rotace;     //rotace planu
extern TPaintBox *pBox;

TPolicko *THraciPlan::Policko(int X,int Y)
{
  TPolicko *policko = polickoStredni;
  while (policko != NULL)
  {
    if (sqrt(pow(policko->pozice.x * kx - X,2) + pow(policko->pozice.y - Y,2)) <= krouzek_r)
      return policko->rotSoused[(6 - rotace) % 6];
    policko = policko->dalsi;
  }
  return NULL;
}

/*void THraciPlan::InicializacePoctuFigurekVChlivcich()
{
  //v chlivcich jsou cizi figurky
  for (int i = 0; i < 3; i++)
    pocetFigurekVChlivecku[i] = hraciPocet - 1;
}*/

THraciPlan::~THraciPlan()
{
  //Zruseni matice metriky
  for (int i = 0; i < rozmerMaticeMetriky; i++)
    delete[] maticeMetriky[i];
  delete[] maticeMetriky;
  //zruseni policek
  TPolicko *policko = polickoStredni, *policko_;
  while (policko!=NULL)
  {
    if (policko->oblast != NULL)
    {
      //policko->SmazKurzor();
      policko->DealokovatKurzor();
    }
    policko_ = policko;
    policko = policko->dalsi;
    delete policko_;
  }
}

bool THraciPlan::JeChlivecekPlny(int orientace)
{
  return (pocetFigurekVChlivecku[orientace] == figurkyPocet) ? true : false;
}

//Korekce metrik se provadi jen pro policka ve spickach
//Neni treba testovat, zda je policko ve spicce.
void THraciPlan::KorekceMetrik(TPolicko *policko,int smer)
{
   if (smer % 2 != 0) return; //korekce se provadi jen pro vychozi policka
   int korekce = -policko->metrika[smer % 3] - rozmer;
   policko->metrika[(smer + 1) % 3] -= korekce;//vlevo
   policko->metrika[(smer + 5) % 3] -= korekce;//vpravo
}

void THraciPlan::TahniFigurkou(TPolicko *polickoStart,TPolicko *polickoCil)
{
  TFigurka *fig = polickoStart->figurka;
  int id;
  if ((id = polickoStart->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  fig->SejmiFigurku();
  fig->policko = polickoCil;
  fig->PostavFigurku();
  if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
}

void THraciPlan::TahniFigurkouVykresli(TPolicko *polickoStart,TPolicko *polickoCil)
{
  TFigurka *fig = polickoStart->figurka;
  int id;
  if ((id = polickoStart->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  fig->SejmiFigurku();
  fig->policko->VykresliPolicko();
  fig->policko = polickoCil;
  fig->VykresliFigurku();
  fig->PostavFigurku();
  if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
}

void THraciPlan::VymenaFigurek(TPolicko *polickoStart,TPolicko *polickoCil)
{
  THrac *hrac;
  TFigurka *figStart = polickoStart->figurka;
  TFigurka *figCil = polickoCil->figurka;
  //if ((id = polickoStart->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  figStart->policko = polickoCil;
  figStart->PostavFigurku();
  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
  hrac = figStart->hracVlastnik;
  hrac->ohodnoceniPozice += polickoCil->metrika[hrac->orientace] - polickoStart->metrika[hrac->orientace];

  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  figCil->policko = polickoStart;
  figCil->PostavFigurku();
  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
  hrac = figCil->hracVlastnik;
  hrac->ohodnoceniPozice += polickoStart->metrika[hrac->orientace] - polickoCil->metrika[hrac->orientace];
}

void THraciPlan::VymenaFigurekVykresli(TPolicko *polickoStart,TPolicko *polickoCil)
{
  THrac *hrac;
  TFigurka *figStart = polickoStart->figurka;
  TFigurka *figCil = polickoCil->figurka;
  //if ((id = polickoStart->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  figStart->policko = polickoCil;
  figStart->VykresliFigurku();
  figStart->PostavFigurku();
  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
  hrac = figStart->hracVlastnik;
  hrac->ohodnoceniPozice += polickoCil->metrika[hrac->orientace] - polickoStart->metrika[hrac->orientace];

  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]--;
  figCil->policko = polickoStart;
  figCil->VykresliFigurku();
  figCil->PostavFigurku();
  //if ((id = polickoCil->idPolicka) >= 0) pocetFigurekVChlivecku[id]++;
  hrac = figCil->hracVlastnik;
  hrac->ohodnoceniPozice += polickoStart->metrika[hrac->orientace] - polickoCil->metrika[hrac->orientace];
}

void THrac::RozestavFigurkyStart()
{
  jeKoncovka = FALSE;
  for(TFigurka *fig=figurky;fig!=NULL;fig=fig->dalsi)
  {
    fig->policko=fig->polickoStart;
    fig->PostavFigurku();
    fig->VykresliFigurku();
  }
  ohodnoceniPozice=0;
  pocetTahu=0;
}

void THraciPlan::VymalujTrojuhelnik(int i)
{
 POINT body[3];
 int ij,j,ir;
 for (j = 0; j < 2; j++)
 {
   ij = ( i + j + rotace + 6) % 6;
   body[j] = Point(kx * (stred.x + poziceHranicni[0][ij].x),stred.y + poziceHranicni[0][ij].y);
 }
 //cip
 ir =(i + rotace + 6) % 6;
 body[2] = Point(kx * (stred.x + poziceHranicni[1][ir].x),stred.y + poziceHranicni[1][ir].y);
 pBox->Canvas->Pen->Width = 0;
 pBox->Canvas->Brush->Color = (TColor)barva[i % 3];
 pBox->Canvas->Polygon(body,2);
 //vykresleni vnejsich trojuhelniku
}

void __fastcall THraciPlan::RotacePlanu(int rotace_)
{
  int i,j,k;
  TPolicko *bod_,*bod;
  rotace_ = (rotace_ + 6) % 6;
  bool zmena = (rotace_ != rotace);
  TPolicko *policko = polickoStredni;
  if (zmena)
    while (policko != NULL)
    {
      if (policko->oblast != NULL) policko->SmazKurzor();
      //if (policko->polickoAnim != NULL) policko->polickoAnim->SmazKurzor();
      policko = policko->dalsi;
    };
  //int rotace__ = rotace;
  rotace = rotace_;
  //Vykresleni pozadi
  //pBox->Canvas->Brush->Color = barvaPozadi;
  //pBox->Canvas->FillRect(Rect(0,0,pBox->Width - 1,pBox->Height - 1));
  //pBox->Canvas->FloodFill(pBox->Width, pBox->Height, barvaPozadi, fsSurface/*fsBorder*/);
  //Vykresleni vyplneneho sestiuhelnika
  pBox->Canvas->Pen->Width = 0;
  pBox->Canvas->Brush->Color = clYellow;
  POINT pole[6];//pomocne pole sestiuhelnika urcujici pozice bodu na obrazovce
  for(i = 0 ; i < 6;i++)
   pole[i] = Point(kx * (stred.x + poziceHranicni[0][i].x),stred.y + poziceHranicni[0][i].y);
  pBox->Canvas->Polygon(pole,5);
  for(i = 0; i < 6; i++) VymalujTrojuhelnik(i);
  rotace = 0;
  TSestice body,body_,body__;
  //Sestice se nastavi na stredni policko
  for(i = 0; i < 6; i++) body[i] = polickoStredni;
  //Vykresleni stredniho policka
  polickoStredni->VykresliVelkyKrouzek(clBlack);
  pBox->Canvas->Pen->Color = clBlack;
  //Rozvinuti planu od stredu
  for(i = 0; i < rozmer; i++)
  {
    //Vysunuti hrotu
    for(j = 0; j < 6; j++)
    {
      body__[j] = body[j];
      body[j] = body__[j]->soused[j];
      body[j]->VykresliVelkyKrouzek(clBlack);
      Usecka(body__[j],body[j]); //sousedstvi rodice a syna hrotu
      body_[j] = body[j];
    }
    //Od hrotu se vytvareji policka po vrstvach
    for(j = 0;j < i; j++)
    {
      for(k = 0; k < 6; k++)//pro vsech 6 vrstev vznikne vzdy jedno policko
      {
        bod_ = body__[k]->soused[(k + 2) % 6];
        bod = bod_->soused[k];
        bod->VykresliVelkyKrouzek(clBlack);
        //sousedstvi bodu bod
        Usecka(bod_,bod);
        Usecka(body__[k],bod);
        Usecka(body_[k],bod);
        body_[k] = bod;
        body__[k] = bod_;
      }
    }
    //Napojeni na sousedni hroty
    for(k = 0; k < 6; k++) Usecka(body_[k],body[(k + 1) % 6]);
  }
  //vykresli policek mezihrany
  for(i = 0; i < 6; i++)
  {
    body[i] = polickoMezi->rotSoused[i];
    body_[i] = body[i];
  }
  for(i = 0; i < rozmer; i++) //do poctu usecek delicich telo planu od spicu
    for(j = 0; j < 6; j++)
    {
      bod = body_[j]->soused[(j + 2) % 6];
      Usecka(body_[j],bod);
      body_[j] = bod;
      body_[j]->VykresliVelkyKrouzek(clBlack);
    }
  //jede se dale k hrotum
  for(i = rozmer; i > 0; i--)
  {
    for(j = 0; j < 6; j++)
    {
      body__[j] = body[j];
      body__[j] = body[j];
      body[j] = body[j]->soused[(j + 1) % 6];
      body[j]->VykresliVelkyKrouzek(clBlack);
      Usecka(body__[j],body[j]); //sousedstvi rodice a syna hrotu
      Usecka(body__[j]->soused[(j + 2) % 6],body[j]);
      body_[j] = body[j];
    }
    //Vysunuti hrotu body
    for(j = 1; j < i; j++)
    {
      for(k = 0; k < 6; k++)
      {
        bod_ = body__[k]->soused[(k+2) % 6];
     	bod = bod_->soused[(k + 1) % 6];
	    bod->VykresliVelkyKrouzek(clBlack);
     	Usecka(bod_->soused[(k + 2) % 6],bod);
    	Usecka(bod_,bod);
	    Usecka(body_[k],bod);
	    body_[k] = bod;
        body__[k] = bod_;
      }
    }
  }
  rotace = rotace_;
  //rozestaveni figurek po rotaci
  policko = polickoStredni;
  while (policko != NULL)
  {
    if (policko->figurka != NULL) policko->figurka->VykresliFigurku();
    if (policko->oblast != NULL)
      if (!zmena) policko->VykresliKurzor();
      else
      {
        policko->DealokovatKurzor();
        policko->UlozitKurzor();
        policko->VykresliKurzor();
      }
    /*if (policko->polickoAnim != NULL)
      if (!zmena) policko->polickoAnim->VykresliKurzor();
      else
      {
        policko->polickoAnim->DealokovatKurzor();
        policko->polickoAnim->UlozitKurzor();
        policko->polickoAnim->VykresliPolicko();
      }*/
    policko = policko->dalsi;
  }
}

int sign(int x)
{
  return (x == 0)?0:x / abs(x);
}

void THraciPlan::Napojeni(TPolicko *rodic,int smer,TPolicko *syn)
{
  syn->pozice.x = rodic->pozice.x + ruzice[smer % 6].x;
  syn->pozice.y = rodic->pozice.y + ruzice[smer % 6].y;
  for(int i = 0; i < 3; i++)
   syn->metrika[i] = syn->vzdalenostOdDomova[i] = rodic->vzdalenostOdDomova[i]
    -sign(ruzice[(6 + smer + 2*(i - 1)) % 6].y);
  //rodic->dalsi=syn;
}


void THraciPlan::Zesousedit(TPolicko *p1,int smer,TPolicko *p2)
{
  p1->soused[smer%6] = p2;
  p2->soused[(smer+3)%6] = p1;
  //Usecka(p1,p2);
  //line(kx*p1->pozice.x,p1->pozice.y,kx*p2->pozice.x,p2->pozice.y);
}

void THraciPlan::Usecka(TPolicko *p1,TPolicko *p2)
{
  //setlinestyle(SOLID_LINE, 1, 3);
  pBox->Canvas->Pen->Width = 1;
  pBox->Canvas->MoveTo(kx * p1->pozice.x,p1->pozice.y);
  pBox->Canvas->LineTo(kx * p2->pozice.x,p2->pozice.y);
}

void THraciPlan::RotacniSousedstvi(TSestice s)
{
  int i,j;
  for(i = 0; i < 6; i++)
    for(j = 0; j < 6; j++)
       s[i]->rotSoused[j] = s[(i+j)% 6];
}

THraciPlan::THraciPlan()
{
 jeAnimace = true;
 ohodnoceniPoziceMax = rozmer * (rozmer + 1) * (rozmer + 2) * 4 / 3;
 ohodnoceniPoziceMin = -1000 * ohodnoceniPoziceMax;
 plochaMax = (3 * rozmer) * (3 * rozmer + 1);
 figurkyPocet = (rozmer + 1) * (rozmer + 2) / 2;
 kx = 1.13;
 stred.y = pBox->Height / 2;
 stred.x = pBox->Width / 2 / kx;

 int d = ((pBox->Height < pBox->Width) ? pBox->Height:pBox->Width) / (4 * rozmer + 1);
 if (d % 2 != 0) d = d-1;
 //stred.x=(3*d*rozmer+d)/2;
 krouzek_r = 1.5F * d / 4;
 krouzek_rm = 1.5F * d / 6;
 int s = d / 2;
 //Nastaveni smeru ruzic
 ruzice[0].x = d; //doprava
 ruzice[0].y = 0;

 ruzice[1].x =s ; //nahoru
 ruzice[1].y = -d;

 ruzice[2].x = -s; //nahoru
 ruzice[2].y = -d;

 ruzice[3].x = -d; //doleva
 ruzice[3].y = 0;

 ruzice[4].x = -s; //dolu
 ruzice[4].y = d;

 ruzice[5].x = s; //dolu
 ruzice[5].y = d;
 //Nastaveni hranicnich bodu trojuhelniku
 int i,j,k;
 for (i = 0;i < 6; i++)
 {
   poziceHranicni[0][i].x = rozmer * ruzice[i].x;
   poziceHranicni[0][i].y = rozmer * ruzice[i].y;
 }
 for (i = 0; i < 6; i++)
 {
   j = (i + 1) % 6;
   poziceHranicni[1][i].x = poziceHranicni[0][i].x + poziceHranicni[0][j].x;
   poziceHranicni[1][i].y = poziceHranicni[0][i].y + poziceHranicni[0][j].y;
 }
 //Nastaveni barev trojuhelnikovych poli
 barva[0] = 0x00FF0000;//clBlue;
 barva[1] = 0x000000FF;//clRed;
 barva[2] = 0x0000FF00;//clGreen;
 TSestice body,body_,body__;//sestice urcuje sest pozic soumernych se
			    //stredem, do kterych se plan rozviji
 TPolicko *bod_,*bod = new TPolicko(); //alokace stredniho policka hraciho pole
 polickoStredni = bod;
 predchozi = bod; //predchozi zajistuje propojeni policek do jedne rady
 bod->pozice.x = stred.x;
 bod->pozice.y = stred.y;
 //Sestice se nastavi na stredni policko
 for(i = 0;i < 6; i++)
 {
   body[i] = bod;
   bod->rotSoused[i] = bod;
 };
 for(i = 0 ; i < 3; i++) bod->metrika[i] = bod->vzdalenostOdDomova[i] = 0;
						//vzdalenosti jsou vztazene
						//ke strednimu policku
 //Rozvinuti planu od stredu
 for(i = 0; i < rozmer; i++)
 {
   //Vysunuti hrotu
   for(j = 0; j < 6; j++)
   {
     body__[j] = body[j];
     body[j] = new TPolicko();
     predchozi->dalsi = body[j];
     predchozi = body[j];
     Napojeni(body__[j],j,body[j]);
     Zesousedit(body__[j],j,body[j]); //sousedstvi rodice a syna hrotu
     body_[j] = body[j];
   }
   RotacniSousedstvi(body);//pri rotaci si body vymeni sve pozice
   //Od hrotu se vytvareji policka po vrstvach
   for(j = 0;j < i; j++)
   {
     for(k = 0; k < 6; k++)//pro vsech 6 vrstev vznikne vzdy jedno policko
     {
       bod_ = body__[k]->soused[(k + 2) % 6];
       bod = new TPolicko();
       predchozi->dalsi = bod;
       predchozi = bod;
       Napojeni(bod_,k,bod);
       //sousedstvi bodu bod
       Zesousedit(bod_,k,bod);
       Zesousedit(body__[k],k + 1,bod);
       Zesousedit(body_[k],k + 2,bod);
       body_[k] = bod;
       body__[k] = bod_;
     }
     RotacniSousedstvi(body_);//policka, ktera vznikla v predchozim cyklu
			      //mohu ucinit sousednimi ve smyslu rotace.
    }
    //Napojeni na sousedni hroty
    for(k = 0; k < 6; k++) Zesousedit(body_[k],k + 2,body[(k + 1) % 6]);
 }

 polickoMezi = body[0];//slouzi pro vykresleni trojuhelniku

 //rozvinuti do spicek
 for(i = rozmer; i > 0; i--)
 {
   //Vysunuti hrotu
   for(j = 0; j < 6; j++) //j je smer vysunuti
   {
     body__[j] = body[j];
     body[j] = new TPolicko();
     predchozi->dalsi = body[j];
     predchozi = body[j];
     Napojeni(body__[j],j + 1,body[j]);
     KorekceMetrik(body[j],j);
     Zesousedit(body__[j],j+1,body[j]); //sousedstvi rodice a syna hrotu
     Zesousedit(body__[j]->soused[(j + 2) % 6],j,body[j]);
     body_[j] = body[j];
   }
   RotacniSousedstvi(body);
   for(j = 1; j < i; j++)
   {
     for(k = 0; k < 6; k++)
     {
       bod_ = body__[k]->soused[(k + 2) % 6];
       bod = new TPolicko();
       predchozi->dalsi = bod;
       predchozi = bod;
       Napojeni(bod_,k + 1,bod);
       KorekceMetrik(bod,k);
       //sousedstvi bodu bod
       Zesousedit(bod_->soused[(k + 2) % 6],k,bod);
       Zesousedit(bod_,k + 1,bod);
       Zesousedit(body_[k],k + 2,bod);
       body_[k] = bod;
       body__[k] = bod_;
     }
     RotacniSousedstvi(body_);
    }
 }
 predchozi->dalsi = NULL;

 //Vytvoreni matice metriky
 rozmerMaticeMetriky = 4 * rozmer + 1;
 posunMaticeMetriky = 2 * rozmer;
 maticeMetriky = new TPolicko**[rozmerMaticeMetriky];
 for (i = 0; i < rozmerMaticeMetriky; i++)
 {
   maticeMetriky[i] = new TPolicko*[rozmerMaticeMetriky];
   for (j = 0; j < rozmerMaticeMetriky; j++)
     maticeMetriky[i][j] = NULL;
 }
 bod = polickoStredni;
 while (bod != NULL)
 {
   maticeMetriky[posunMaticeMetriky + bod->vzdalenostOdDomova[1]]
                [posunMaticeMetriky + bod->vzdalenostOdDomova[0]] = bod;
   bod = bod->dalsi;
 }
 //Stanoveni id policek ve chliveckach  a jejich zretezeni
 for(k = 0; k < 6; k += 2)
 {
   bod = polickoMezi->rotSoused[k + 1];
   for(i = rozmer; i > 0; i--)
   {
     bod_ = bod;
     bod_->idPolicka = (k + 4) % 3; //hodnota odpovida orientaci hrace
     for(j = 0; j < i; j++)
     {
       bod_ = bod_->dalsiVChlivci = bod_->soused[(k + 3) % 6];
       bod_->idPolicka = (k + 4) % 3; //hodnota odpovida orientaci hrace
     }
     bod_->dalsiVChlivci = bod = bod->soused[(k + 2) % 6];
   }
   bod->dalsiVChlivci = NULL;
   bod->idPolicka = (k + 4) % 3; //hodnota odpovida orientaci hrace
 }

 //Vypocita se vychozi umisteni figurek
 TFigurka *fig;
 for(k = 0; k < 6; k += 2)
 {
   fig = NULL;
   bod = polickoMezi->rotSoused[k];
   //hracUdaje[k].chlivecek=polickoMezi->rotSoused[(hracUdaje[k].orientace + 3) % 6];
   for(i = rozmer; i >= 0; i--)
   {
     bod_ = bod;
     for(j = 0; j <= i; j++)
     {
       if (fig != NULL)
       {
	     fig->dalsi = new TFigurka;
	     fig = fig->dalsi;
       }
       else fig = new TFigurka;
       fig->policko = fig->polickoStart = bod_;
       bod_->figurka = fig;
       fig->barva = barva[k % 3];
       bod_ = bod_->soused[(k + 2) % 6];
     }
     bod = bod->soused[(k + 1) % 6];
   }
   if (fig != NULL) fig->dalsi = NULL;
 }
}

void THraciPlan::PrepnoutAnimaci()
{
  //Zapnuti a vypnuti animace tahu figurek
  jeAnimace = !jeAnimace;
}
